%{
#include <stdio.h>
#include <stdlib.h>
#include<string.h>
#include "structs.h"
int yydebug=1;
int start=1;
extern int lineNo;
int is_in_with=0;
char* lexeme_with;

#define TYPE_ERROR -2
#define TYPE_VOID -1
#define TYPE_UNKNOWN -3
#define TYPE_INT 1
#define TYPE_REAL 2
#define TYPE_CARD 3
#define TYPE_BOOLEAN 4
#define TYPE_STRING 5
#define TYPE_CHAR 6
#define TYPE_ARRAY 7
#define TYPE_RECORD 8
#define TYPE_POINTER 9
#define TYPE_SET 10
#define TYPE_PROCEDURE 11
#define TYPE_Z 12
#define TYPE_SUBRANGE 13

#define INFO 2
//global variables
TableStack *scope_stack;	//stack of scopes
TypeCons* ZType;
TypeCons* CardType;
TypeCons* IntType;
TypeCons* RealType;
TypeCons* StringType;
TypeCons* BooleanType;
TypeCons* CharType;
TypeCons* ErrorType;
TypeCons* VoidType;
TypeCons* CardinalType;
TypeCons* ProcedureType;
TypeCons* returntype;
SymbolTableEntry* currentproc;
int tempcount, labelcount, addr, argcount, tempareasize, paramnumber, camefirsttime, global_rec_offset;
FILE* intercode;
Icode* icodelist;
void traverse_identifier_list(TableStack* identi){
        TableStack* temp;
        temp=identi;
}
TypeCons* copy_type(TypeCons* t){

        return t;
}

void breakup(char* s){
	int i=0;
	while(s[i]!='\0')printf("%c ",s[i++]);
}
void init(){
	scope_stack=(TableStack*)malloc(sizeof(TableStack));
	scope_stack->top =NULL;
	scope_stack->next=NULL;
	scope_stack->offset=0;
	currentproc=NULL;
	paramnumber=0;
	IntType=(TypeCons*)malloc(sizeof(TypeCons));
	RealType=(TypeCons*)malloc(sizeof(TypeCons));
	StringType=(TypeCons*)malloc(sizeof(TypeCons));
	BooleanType=(TypeCons*)malloc(sizeof(TypeCons));
	CharType=(TypeCons*)malloc(sizeof(TypeCons));
	ErrorType=(TypeCons*)malloc(sizeof(TypeCons));
	VoidType=(TypeCons*)malloc(sizeof(TypeCons));
	CardinalType=(TypeCons*)malloc(sizeof(TypeCons));
	ProcedureType=(TypeCons*)malloc(sizeof(TypeCons));
	CardType=(TypeCons*)malloc(sizeof(TypeCons));
	ZType=(TypeCons*)malloc(sizeof(TypeCons));
	
	IntType->type=TYPE_INT;
	RealType->type=TYPE_REAL;
	StringType->type=TYPE_STRING;
	BooleanType->type=TYPE_BOOLEAN;
	CharType->type=TYPE_CHAR;
	ErrorType->type=TYPE_ERROR;
	VoidType->type=TYPE_VOID;
	CardinalType->type=TYPE_CARD;
	ProcedureType->type=TYPE_PROCEDURE;
	ZType->type=TYPE_Z;
	

	IntType->size=4;
	RealType->size=4;
	StringType->size=4;
	BooleanType->size=4;
	CharType->size=4;
	ErrorType->size=0;
	VoidType->size=0;
	CardinalType->size=4;
	ProcedureType->size=0;
	ZType->size=4;

	IntType->descriptor=NULL;
	RealType->descriptor=NULL;
	StringType->descriptor=NULL;
	BooleanType->descriptor=NULL;
	CharType->descriptor=NULL;
	ErrorType->descriptor=NULL;
	VoidType->descriptor=NULL;
	CardinalType->descriptor=NULL;
	ProcedureType->descriptor=NULL;
	
	tempareasize=0;
	tempcount=-1;
	labelcount=0;
	icodelist=NULL;
	addr=0;
	argcount=0;
	camefirsttime=1;
        global_rec_offset=0;
	}
int isEqual(TypeCons* a, TypeCons* b){
	if(a ==NULL){
		if(b==NULL){
			//printf("Warning: isEqual called with null types\n");
			return 1;
		}
		return 0;
	}
	if(b==NULL)return 0;
	if(a->type==b->type)	{
		if((a->name!=NULL && b->name==NULL) || (b->name!=NULL && a->name==NULL)){
			return 0;
		}
		else if (a->name!=NULL && b->name!=NULL && strcmp(a->name, b->name)!=0){
			printf("Error: in line %d:  variable of type %s cannot be assigned to variable of type %s\n", lineNo,b->name, a->name);
			return 0;
		}
		return isEqual(a->descriptor, b->descriptor);
	}
	if(
	(a->type==TYPE_Z &&(b->type==TYPE_INT||b->type==TYPE_CARD))
    || (b->type==TYPE_Z && (a->type==TYPE_INT||a->type==TYPE_CARD))
    || (a->type==TYPE_INT && (b->type==TYPE_INT||b->type==TYPE_CARD))
    || (a->type==TYPE_CARD && (b->type==TYPE_CARD))
	)return isEqual(a->descriptor, b->descriptor);
	return 0;
}
int isProperType(TypeCons* a){
	return (a->type > 0);
}
void append(TableStack *ts, SymbolTableEntry *tobeadded){
	if(tobeadded==NULL){
		fprintf(stderr,"ERROR: adding null entry to symbol table\n");
		exit(1);
	}
	if(ts==NULL){
		fprintf(stderr, "SERIOUS ERROR: null scope!\n");
		exit(1);
	}
	tobeadded->next=ts->top;
	ts->top=tobeadded;
}
void append_lists(TableStack* a, TableStack* b){
	
	if(a->next==NULL)a->next=b;
	else append_lists(a->next, b);
}
SymbolTableEntry* lookup(SymbolTableEntry *top, char* lexeme){
/*	if(top!=NULL)printf("Looking up %s: Top %s\n Width: %d, Offset %d",lexeme, top->lexeme, top->width, top->offset);
	else printf("Reached end of symbol table\n");
*/	if(top==NULL){
		if(scope_stack->next==NULL || scope_stack->declhappening == 1 )
			return NULL;
		else {
	//		printf("One level down\n");
			TableStack* old=scope_stack;
			scope_stack=scope_stack->next;
			SymbolTableEntry* temp=lookup(scope_stack->top, lexeme);
			scope_stack=old;
			return temp;
		}
	}
	else if(strcmp(lexeme, top->lexeme)==0) {
	//	printf("Found\n");
		return top;
	}
/*	else if(strcmp(top->lexeme,"AreaOfSq")==0){
		breakup(top->lexeme);
		printf("world is sane");
	}
*/	return lookup(top->next, lexeme);
}
void append_list(TableStack* ts, SymbolTableEntry* tobeadded){
	if(ts->next==NULL){
	//	printf("Reached end of list. Last lexeme %s\n",ts->top->lexeme);
		TableStack* newstack=(TableStack*)malloc(sizeof(TableStack));
		newstack->next=NULL;
		newstack->top=tobeadded;
		//newstack->fromCurrentScope=fromCScope;
	//	printf("appended %s\n",newstack->top->lexeme);
		ts->next=newstack;
		return;
	}
	if(tobeadded==NULL){
	//	printf("Warning: attempting to add null ste to stelist\n");
	}
	//printf("Passed %s\n",ts->top->lexeme);
	append_list(ts->next, tobeadded);
}
void traverse(TableStack* ts){
/*	if(ts==NULL)return;
	//printf("Lexeme %s ",ts->top->lexeme);
	if(ts->top->type!=NULL)printf("Type %d\n",ts->top->type->type);
	else printf("Type NULL\n");
	traverse(ts->next);*/
}
void init_node(Node* n){
	n=(Node*)malloc(sizeof(Node));
}
void assign_types(TableStack* iden_list, Node* unode){
	if(iden_list==NULL)return;
	//printf("Assigning type %d to %s isdecl %d scope %d\n",unode->type->type, iden_list->top->lexeme, iden_list->top->isdecl, scope_stack->declhappening);
//	if(unode->type->name!=NULL)printf("Assign %s %s\n",iden_list->top->lexeme, unode->type->name);
	if(iden_list->top->isdecl==0 || scope_stack->declhappening == 1 ){
		iden_list->top->isdecl=1;
		iden_list->top->type=unode->type;
		iden_list->top->width=unode->type->size;
		iden_list->top->offset=addr;
		addr+=unode->type->size;
		iden_list->top->width=unode->type->size;
		printf("var: %s, offset: %d, width %d \n",iden_list->top->lexeme, iden_list->top->offset, iden_list->top->width);
		//printf("%s assigned type %d\n",iden_list->top->lexeme,unode->type->type);
	}
	else{
		printf("Error: in line %d : \" %s \" redeclared\n", lineNo, iden_list->top->lexeme);
	}
	assign_types(iden_list->next, unode);
}
void listify(TableStack* iden_list, Node* unode){
	assign_types(iden_list,unode);
	
}
void ste_copy(SymbolTableEntry* a, SymbolTableEntry* b){
	a->lexeme=strdup(b->lexeme);
	a->isdecl=b->isdecl;
	a->next=b->next;
	a->type=b->type;
	a->idclass=b->idclass;
}
int isCompatible(TableStack* args, Node* unode){
	if(args==NULL && unode==NULL)return 1;
	if(args==NULL) {
	//	printf("First one small\n");
		return 0;
	}
	if(unode==NULL){
	//	printf("Second one small\n");
		return 0;
	}
	//if(args->top->type!=NULL && unode->type!=NULL)
	//	printf("Top: %d %d\n",args->top->type->type, unode->type->type);
	if(isEqual(args->top->type, unode->type)){
		return isCompatible(args->next, unode->next);
	}
	return 0;
}
Node* append_at_end(Node* l1, Node* l2){
	if(l1 == NULL)	return l2;
	l1->next=append_at_end(l1->next,l2);
	return l1;
}
int lengthof(Node* list){
	if(list==NULL)return 0;
	return 1+lengthof(list->next);
}
int lengthoflist(TableStack* ts){
	if(ts==NULL)return 0;
	return 1+lengthoflist(ts->next);
}
int fill_array_index_dims(TypeCons** index, Node* ranges){
	Node* temp=ranges;
	int i=0;
	while(temp!=NULL){
		index[i]=(TypeCons*)malloc(sizeof(TypeCons));
//		printf("came here!! %d\n", i);
//		printf("size: %d\n",temp->type->size);
		index[i]->size=temp->type->size;
		temp=temp->next;
		i++;
	}
}
void addicode(Quad* q){
	Icode* newhead=(Icode*)malloc(sizeof(Icode));
	newhead->next=icodelist;
	newhead->code=q;
	icodelist=newhead;
}
Icode* append_line_to_list(Icode* list, Quad* line){
	Icode* newhead=(Icode*)malloc(sizeof(Icode));
	newhead->next=list;
	newhead->code=line;
//	if(line==NULL)printf("Error ::: trying to add null code\n");
	if(list!=NULL && line!=NULL){
		newhead->width=list->width+line->width;
	}
	else{
		newhead->width=0;//line->width;
	}
	
	if(list!=NULL)newhead->offset=list->offset;
	else newhead->offset=0;
	return newhead;
}
Icode* append_codelists(Icode* list1, Icode* list2){
	if(list2==NULL) {
		//printf("list2 was null");
		return list1;
	}
	Icode* temp;
	temp=list2;
	while(temp->next!=NULL){
		temp=temp->next;
	}
	temp->next=list1;
	//newhead->width=list1->width+list2->width;
	//newhead->offset=list1->offset;
	
	return list2;
}
void dumpassigncode(Quad* code, FILE* file){
        //fprintf(file,":=");
	//fprintf(file,"assigncode\n");
        if(code->switch1){
		if(currentproc==NULL)
        	fprintf(file, "\tlw $t0, %d($sp)\n",addr+code->arg1temp*4);
		else
        	fprintf(file, "\tlw $t0, %d($sp)\n",currentproc->localdatasize+code->arg1temp*4);
        }
        else{
		if(code->arg1!=NULL && code ->arg1->code !=NULL && code->arg1->code->offset>0){
			if(currentproc==NULL)
        			fprintf(file, "\tlw $t1, %d($sp)\n",addr+code->arg1->code->offset*4);
			else
        			fprintf(file, "\tlw $t1, %d($sp)\n",currentproc->localdatasize+code->arg1->code->offset*4);
			fprintf(file, "\tadd $t2, $t1, $sp\n");
			fprintf(file, "\tlw $t0, %d($t2)\n",code->arg1->offset);
			
		}
		else{
			fprintf(file, "\tlw $t0, %d($sp)\n",code->arg1->offset);
		}
        }
        if(code->switch2){
		if(currentproc==NULL)
        	fprintf(file, "\tlw $t1, %d($sp)\n",addr+code->arg2temp*4);
		else
        	fprintf(file, "\tlw $t1, %d($sp)\n",currentproc->localdatasize+code->arg2temp*4);
	       
        }
        else{
        	if(code->arg2!=NULL && code->arg2->code !=NULL &&  code->arg2->code->offset>0){
			if(currentproc==NULL)
        			fprintf(file, "\tlw $t1, %d($sp)\n",addr+code->arg2->code->offset*4);
			else
        			fprintf(file, "\tlw $t1, %d($sp)\n",currentproc->localdatasize+code->arg2->code->offset*4);
			fprintf(file, "\tadd $t2, $t1, $sp\n");
			fprintf(file, "\tlw $t1, %d($t2)\n",code->arg2->offset);
			
		}
		else{
			fprintf(file, "\tlw $t1, %d($sp)\n",code->arg2->offset);
		}
	}
        if(strcmp(code->op,"+")==0){
		fprintf(file, "\tadd $t2, $t0, $t1\n");
	}
	else if(strcmp(code->op,"-")==0){
		fprintf(file, "\tsub $t2, $t0, $t1\n");
	}
	else if(strcmp(code->op,"*")==0){
		fprintf(file, "\tmult $t0, $t1\n");
		fprintf(file, "\tmflo $t2\n");
	}
	else if(strcmp(code->op,"/")==0){
		fprintf(file, "\tdiv $t0, $t1\n");
		fprintf(file, "\tmflo $t2\n");
		
	}
	else if(strcmp(code->op,"MOD")==0){
		fprintf(file, "\tdiv $t0, $t1\n");
		fprintf(file, "\tmfhi $t2\n");
		
	}	
        if(code->switch3){
            
		if(currentproc==NULL){
        		fprintf(file, "\tsw $t2, %d($sp)\n",addr+code->restemp*4);
		}
		else{
        		fprintf(file, "\tsw $t2, %d($sp)\n",currentproc->localdatasize+code->restemp*4);
		}
        }
        else{
        	fprintf(file, "\tsw $t2, %d($sp)\n",code->res->offset+code->offset);
		//fprintf(file, "\t it does come here\n");	
        }
}

void dumpassign(Quad* code, FILE* file){
	//fprintf(file,"assign\n");
	if(code->switch3){
		fprintf(file, "t%d",code->restemp);
	}
	else{
		fprintf(file, "%s",code->res->lexeme);
		if(code->offset!=0){
			fprintf(file, "[t%d]",code->offset);
		}
	}
	fprintf(file,":=");
	if(code->switch1){
		fprintf(file, "t%d",code->arg1temp);
	}
	else{
		fprintf(file, "%s",code->arg1->lexeme);
		if(code->offset!=0){
			fprintf(file, "[t%d]",code->offset);
		}
	}
	fprintf(file, "%s",code->op);
	if(code->switch2){
		fprintf(file, "t%d",code->arg2temp);
	}
	else{
		fprintf(file, "%s",code->arg2->lexeme);
		if(code->offset!=0){
			fprintf(file, "[t%d]",code->offset);
		}
	}
	fprintf(file, "\n");
	
}
void dumpcopycode(Quad* code, FILE* file){
	//fprintf(file,"copycode\n");

	int repeat=0;
	int totalsize=0;
	if(!code->switch1 && !code->switch3){
		totalsize=code->arg1->type->size;
	//	fprintf(file, "total size %d\n",totalsize);
	}
	do{
	if(code->switch1){
		if(currentproc==NULL)
        	fprintf(file, "\tlw $t0, %d($sp)\n",addr+code->arg1temp*4);
		else
        	fprintf(file, "\tlw $t0, %d($sp)\n",currentproc->localdatasize+code->arg1temp*4);
	}
	else{
		fprintf(file, "\tlw $t0, %d($sp)\n",code->arg1->offset+repeat);
	}
	if(code->switch3){
		if(currentproc==NULL)
        	fprintf(file, "\tsw $t0, %d($sp)\n",addr+code->restemp*4);
		else
        	fprintf(file, "\tsw $t0, %d($sp)\n",currentproc->localdatasize+code->restemp*4);
	}
	else{
		if(code->offset>0){
		if(currentproc==NULL)
        	fprintf(file, "\tlw $t1, %d($sp)\n",addr+code->offset*4);
		else
        	fprintf(file, "\tlw $t1, %d($sp)\n",currentproc->localdatasize+code->offset*4);
		fprintf(file, "\tadd $t2, $t1, $sp\n");
		
		fprintf(file, "\tsw $t0, %d($t2)\n",code->res->offset);
		}
		else{
		fprintf(file, "\tsw $t0, %d($sp)\n",code->res->offset+repeat);
		}
	}
	repeat+=4;
	}while(totalsize>repeat);
}
void dumpcopy(Quad* code, FILE* file){
	if(code->switch3){
		fprintf(file, "t%d",code->restemp);
	}
	else{
		fprintf(file, "%s",code->res->lexeme);
		//fprintf(file,"dumpcopy");
		if(code->offset!=0){
			fprintf(file, "[t%d]",code->offset);
		}
	}
	fprintf(file,":=");
	if(code->switch1){
		fprintf(file, "t%d",code->arg1temp);
	}
	else{
		fprintf(file, "%s",code->arg1->lexeme);
		if(code->offset!=0){
		//	fprintf(file, "[t%d]",code->offset);
		}
	}
	fprintf(file, "\n");
	
}
void dumpcopyconstcode(Quad* code, FILE* file){
	//fprintf(file,"copyconstcode\n");
	
	fprintf(file, "\taddi $t0, $0, %s\n", code->str);
	if(code->switch3){
		if(currentproc==NULL){
        		fprintf(file, "\tsw $t0, %d($sp)\n",addr+code->restemp*4);
		}
		else{
			
        		fprintf(file, "\tsw $t0, %d($sp)\n",currentproc->localdatasize+code->restemp*4);
		}
	}
	else{
		fprintf(file, "\tsw %d($sp), $t0\n",code->res->offset+code->offset);
	}	
}
void dumpcopyconst(Quad* code, FILE* file){
	if(code->switch3){
		fprintf(file, "t%d",code->restemp);
	}
	else{
		fprintf(file, "%s",code->res->lexeme);
		if(code->offset!=0){
			fprintf(file, "[t%d]",code->offset);
		}
	}
	fprintf(file,":=");
	fprintf(file, "%s\n", code->str);
	
}
void dumpifxrelopy(Quad* code, FILE* file){
	fprintf(file, "if ");
	if(code->switch1){
		fprintf(file, "t%d",code->arg1temp);
	}
	else{
		fprintf(file, "%s",code->arg1->lexeme);
		if(code->offset!=0){
			fprintf(file, "[t%d]",code->offset);
		}
	}
	fprintf(file, "%s",code->op);
	if(code->switch2){
		fprintf(file, "t%d",code->arg2temp);
	}
	else{
		fprintf(file, "%s",code->arg2->lexeme);
		if(code->offset!=0){
			fprintf(file, "[t%d]",code->offset);
		}
	}
	fprintf(file, " goto L%d\n", code->label);
}
void dumpifxrelopycode(Quad* code, FILE* file){
	//fprintf(file,"ifxrelopycode");
	if(code->switch1){
		//fprintf(file, "\tlw $t0, %d($sp)\n",addr+code->arg1temp*4);
		if(currentproc==NULL)
        	fprintf(file, "\tlw $t0, %d($sp)\n",addr+code->arg1temp*4);
		else
        	fprintf(file, "\tlw $t0, %d($sp)\n",currentproc->localdatasize+code->arg1temp*4);
	}
	else{
		if(code->arg1!=NULL && code ->arg1->code !=NULL && code->arg1->code->offset>0){
			if(currentproc==NULL)
        			fprintf(file, "\tlw $t1, %d($sp)\n",addr+code->arg1->code->offset*4);
			else
        			fprintf(file, "\tlw $t1, %d($sp)\n",currentproc->localdatasize+code->arg1->code->offset*4);
			fprintf(file, "\tadd $t2, $t1, $sp\n");
			fprintf(file, "\tlw $t0, %d($t2)\n",code->arg1->offset);
			
		}
		else{
			fprintf(file, "\tlw $t0, %d($sp)\n",code->arg1->offset);
		}
		//fprintf(file, "\tlw $t1, %d($sp)\n",code->arg1->offset+code->offset);
	}
	if(code->switch2){
		//fprintf(file, "\tlw $t0, %d($sp)\n",addr+code->arg2temp*4);
		if(currentproc==NULL)
        	fprintf(file, "\tlw $t1, %d($sp)\n",addr+code->arg2temp*4);
		else
        	fprintf(file, "\tlw $t1, %d($sp)\n",currentproc->localdatasize+code->arg2temp*4);
	}
	else{
		if(code->arg2!=NULL && code->arg2->code !=NULL && code->arg2->code->offset>0){
			if(currentproc==NULL)
        			fprintf(file, "\tlw $t1, %d($sp)\n",addr+code->arg2->code->offset*4);
			else
        			fprintf(file, "\tlw $t1, %d($sp)\n",currentproc->localdatasize+code->arg2->code->offset*4);
			fprintf(file, "\tadd $t2, $t1, $sp\n");
			fprintf(file, "\tlw $t1, %d($t2)\n",code->arg1->offset);
			
		}
		else{
			fprintf(file, "\tlw $t1, %d($sp)\n",code->arg1->offset);
		}
		//fprintf(file, "\tlw $t1, %d($sp)\n",code->arg2->offset+code->offset);
	}
	if(strcmp(code->op,">")==0){
		fprintf(file,"\tsgt $t2, $t0, $t1\n");
		fprintf(file,"\tbne $t2, $0, L%d\n",code->label);
	}
	if(strcmp(code->op,"<=")==0){
		fprintf(file,"\tsgt $t2, $t1, $t0\n");
		fprintf(file,"\tbne $t2, $0, L%d\n",code->label);
	}
	
	if(strcmp(code->op,"<")==0){
		fprintf(file,"\tslt $t2, $t0, $t1\n");
		fprintf(file,"\tbne $t2, $0, L%d\n",code->label);
	}
	if(strcmp(code->op,">=")==0){
		fprintf(file,"\tslt $t2, $t1, $t0\n");
		fprintf(file,"\tbne $t2, $0, L%d\n",code->label);
	}
	if(strcmp(code->op,"=")==0){
		fprintf(file,"\tbeq $t0, $t1, L%d\n",code->label);
	}
	if(strcmp(code->op,"<>")==0){
		fprintf(file,"\tbne $t0, $t1, L%d\n",code->label);
	}
}
void dumpcondjump(Quad* code, FILE* file){
	fprintf(file, "ifnot ");
	if(code->switch3){
		fprintf(file, "t%d",code->restemp);
	}
	else{
		fprintf(file, "problem %s",code->arg1->lexeme);
	}
	fprintf(file, " goto L%d\n", code->label);

}
void dumpcondjumpcode(Quad* code, FILE* file){
	if(currentproc==NULL)
        fprintf(file, "\tlw $t0, %d($sp)\n",addr+code->restemp*4);
	else
        fprintf(file, "\tlw $t0, %d($sp)\n",currentproc->localdatasize+code->restemp*4);
	if(!code->switch3){
		fprintf(file, "problem %s",code->arg1->lexeme);
	}
	fprintf(file, "\tbeq $t0, $0, L%d\n", code->label);
}
void dumplabelcode(Quad* code, FILE* file){
	fprintf(file, "L%d:\n",code->label);
}
void dumplabel(Quad* code, FILE* file){
	fprintf(file, "L%d:\n",code->label);
}
void dumpuncondjumpcode(Quad* code, FILE* file){
	fprintf(file, "\tj L%d\n",code->label);
}
void dumpuncondjump(Quad* code, FILE* file){
	fprintf(file, "goto L%d\n",code->label);
}


void dumpreturncode(Quad* code, FILE* file){
//	if(code->arg1!=NULL){
	if(code->switch1==1){
		if(currentproc==NULL)
        	fprintf(file, "\tlw $t0, %d($sp)\n",addr+code->arg1temp*4);
		else
        	fprintf(file, "\tlw $t0, %d($sp)\n",currentproc->localdatasize+code->arg1temp*4);

	}
	else{
		if(code->offset>0){
			if(currentproc==NULL)
        			fprintf(file, "\tlw $t1, %d($sp)\n",addr+code->offset*4);
			else
        			fprintf(file, "\tlw $t1, %d($sp)\n",currentproc->localdatasize+code->offset*4);
			fprintf(file, "\tadd $t2, $t1, $sp\n");
			fprintf(file, "\tlw $t0, %d($t2)\n",code->arg1->offset);
			
		}
		else{
			if(code->arg1!=NULL)fprintf(file, "\tlw $t0, %d($sp)\n",code->arg1->offset);
		}
	}
	fprintf(file, "\tsw $t0, 0($fp)\n");
	fprintf(file, "\taddi $sp, $fp, %d\n",4*INFO+4);
	fprintf(file, "\tlw $fp, -4($sp)\n");
	//fprintf(file, "\taddi $ra, $sp, -%d\n",8);
	fprintf(file, "\tjr $ra\n");
}


void dumpreturn(Quad* code, FILE* file){
	if(code->switch1==0){
		if(code->arg1!=NULL)fprintf(file, "return %s\n",code->arg1->lexeme);
		else fprintf(file,"return\n");
	}
	else{
		if(code->arg1temp>=0){
			fprintf(file,"return t%d\n",code->arg1temp);
		}
		else{
			fprintf(file, "return\n");
		}
	}
}
void dumpendcode(FILE* file){
	fprintf(file,"\tli $v0, 10\n");
       	fprintf(file,"\tsyscall\n");
	fprintf(file,"\n#END MAIN\n\n");
	
}
void dumpproccode(Quad* code, FILE* file){
	if(camefirsttime)dumpendcode(file);
	camefirsttime=0;
	fprintf(file, "%s:\n",code->arg1->lexeme);
	currentproc=code->arg1;
}
void dumpproc(Quad* code, FILE* file){
	fprintf(file, "PROC %s\n",code->arg1->lexeme);
}
void dumpparamcode(Quad* code, FILE* file){
	//fprintf(file, "param:");
	paramnumber++;
	//fprintf(file, "temp id :%d addr %d", code->arg1temp, addr);
	int tempaddr=(currentproc==NULL)?addr:currentproc->localdatasize;
	tempaddr+=4*code->arg1temp;
	if(!code->switch1){
		if(code->offset > 0){
		if(currentproc==NULL)
        	fprintf(file, "\tlw $t1, %d($sp)\n",addr+code->offset*4);
		else
        	fprintf(file, "\tlw $t1, %d($sp)\n",currentproc->localdatasize+code->offset*4);
		fprintf(file, "\tadd $t2, $t1, $sp\n");
		
		fprintf(file, "\tlw $t0, %d($t2)\n", code->arg1->offset);
		}
		else{
			
		fprintf(file, "\tlw $t0, %d($sp)\n", code->arg1->offset);
		}
	}
	else{
	fprintf(file, "\tlw $t0, %d($sp)\n", tempaddr);
	}

	int destaddr=4*INFO+paramnumber*4;
	fprintf(file, "\tsw $t0, -%d($sp)\n", destaddr);
	
}
void dumpparam(Quad* code, FILE* file){
	
	fprintf(file, "param ");
	if(code->switch1){
		fprintf(file, "t%d\n",code->arg1temp);
	}
	else{
		fprintf(file, "%s",code->arg1->lexeme);
		if(code->offset!=0){
			fprintf(file, "[t%d]",code->offset);
		}
		fprintf(file,"\n");
	}
}
void dumpcallvalcode(Quad* code, FILE* file){
	paramnumber=0;
	int newsp=4*INFO+code->arg1->localdatasize+code->arg1->scope->tempareasize;
	int i=0;
	for(i=0;i<code->arg1temp;i++){
		fprintf(file, "\tlw $t0, -%d($sp)\n",4+4*i+4*INFO);
		fprintf(file, "\tsw $t0, -%d($sp)\n",-4*i+newsp);
	}
	fprintf(file, "\tsw $fp, -4($sp)\n");
	fprintf(file, "\tsw $ra, -8($sp)\n");
	fprintf(file, "\taddi $fp, $sp, -%d\n",4*INFO+4);
	fprintf(file ,"\taddi $sp, $sp, -%d\n",newsp);
	fprintf(file, "\tjal %s\n",code->arg1->lexeme);
	fprintf(file, "\tlw $ra, -8($sp)\n");
	fprintf(file, "\tlw $t0, -%d($sp)\n",4*INFO+4);
	if(currentproc==NULL)
       	fprintf(file, "\tsw $t0, %d($sp)\n",addr+code->restemp*4);
	else
       	fprintf(file, "\tsw $t0, %d($sp)\n",currentproc->localdatasize+code->restemp*4);
}
void dumpcallcode(Quad* code, FILE* file){
	paramnumber=0;	
	int newsp=4*INFO+code->arg1->localdatasize+code->arg1->tempareasize;
	int i=0;
	for(i=0;i<code->arg1temp;i++){
		fprintf(file, "\tlw $t0, -%d($sp)\n",4+4*i+4*INFO);
		fprintf(file, "\tsw $t0, -%d($sp)\n",-4*i+newsp);
	}
	//fprintf(file, "calling func");
	fprintf(file, "\tsw $fp, -4($sp)\n");
	fprintf(file, "\tsw $ra, -8($sp)\n");
	fprintf(file, "\taddi $fp, $sp, -%d\n",4*INFO+4);
	fprintf(file ,"\taddi $sp, $sp, -%d\n",newsp);
	fprintf(file, "\tjal %s\n",code->arg1->lexeme);
	fprintf(file, "\tlw $ra, -8($sp)\n");
}
void dumpcallval(Quad* code, FILE* file){
	fprintf(file, "t%d := call %s,%d\n", code->restemp, code->arg1->lexeme, code->arg1temp);
}
void dumpcall(Quad* code, FILE* file){
	fprintf(file, "call %s,%d\n", code->arg1->lexeme, code->arg1temp);
}
void dumpconstopcode(Quad* code, FILE* file){

	//fprintf(file, "constopcode");
	if(code->switch1){
		//fprintf(file, "\tlw $t0 %d($sp)\n",addr+code->arg1temp*4);
		if(currentproc==NULL)
        	fprintf(file, "\tlw $t0, %d($sp)\n",addr+code->arg1temp*4);
		else
        	fprintf(file, "\tlw $t0, %d($sp)\n",currentproc->scope->width+code->arg1temp*4);
	}
	else{
		fprintf(file, "\tlw $t0, %d($sp)\n",code->arg1->offset+code->offset);
	}
	if(strcmp(code->op,"+")==0){
		fprintf(file, "\taddi $t1, $t0, %d\n",code->arg2temp);
	}
	else if(strcmp(code->op,"-")==0){
		fprintf(file, "\taddi $t1, $t0, -%d\n",code->arg2temp);
	}
	else if(strcmp(code->op,"*")==0){
		fprintf(file,"\taddi $t5, $0, %d\n",code->arg2temp);
		fprintf(file, "\tmult $t0, $t5\n");
		fprintf(file, "\tmflo $t1\n");
	}
	else if(strcmp(code->op,"/")==0){
		fprintf(file, "\tdivi $t0, %d\n",code->arg2temp);
		fprintf(file, "\tmflo $t1\n");
	}
	//fprintf(file, "%d\n",code->arg2temp);
	//fprintf(file, "\taddi $t1, $t0, %d\n",code->arg2temp);
	if(code->switch3){
		if(currentproc==NULL)
        	fprintf(file, "\tsw $t1, %d($sp)\n",addr+code->restemp*4);
		else
        	fprintf(file, "\tsw $t1, %d($sp)\n",currentproc->scope->width+code->restemp*4);
	}
	else{
		fprintf(file, "\tsw $t1, %d($sp)\n",code->res->offset+code->offset);
	}
	if(!code->switch2){
		fprintf(file, "problem in dumpconstopcode\n");
	}
}
void dumpconstop(Quad* code, FILE* file){

	//fprintf(file, "constop");
	if(code->switch3){
		fprintf(file, "t%d",code->restemp);
	}
	else{
		fprintf(file, "%s",code->res->lexeme);
		if(code->offset!=0){
			fprintf(file, "[t%d]",code->offset);
		}
	}
	fprintf(file,":=");
	if(code->switch1){
		fprintf(file, "t%d",code->arg1temp);
	}
	else{
		fprintf(file, "%s",code->arg1->lexeme);
		if(code->offset!=0){
			fprintf(file, "[t%d]",code->offset);
		}
	}
	fprintf(file, "%s",code->op);
	if(code->switch2){
		fprintf(file, "%d",code->arg2temp);
	}
	else{
		fprintf(file, "problem %s",code->arg2->lexeme);
		if(code->offset!=0){
			fprintf(file, "[t%d]",code->offset);
		}
	}
	fprintf(file, "\n");
}

void dumpprintcode(Quad* code, FILE* file){
	fprintf(file,"WriteInt:\n\tlw $a0, 0($sp)\n\tli $v0, 1\n\tsyscall\n\tlw $sp, 12($fp)\n\tlw $fp, -4($sp)\n\tjr $ra\n");
	
}
void dumpprint(Quad* code, FILE* file){
	fprintf(file,"print\n");

}
void dumpicode(Icode* codelist, FILE* file, FILE* codefile){
	if(codelist!=NULL) {
	if(codelist->next!=NULL)dumpicode(codelist->next,file, codefile);
	switch(codelist->code->type){
		case 0:	dumpassign(codelist->code, file);
			dumpassigncode(codelist->code, codefile);
			break;
		case 1: dumpcopy(codelist->code, file);
			dumpcopycode(codelist->code, codefile);
			break;
		case 2: dumpcopyconst(codelist->code, file);
			dumpcopyconstcode(codelist->code, codefile);
			break;
		case 3: dumpcondjump(codelist->code, file);
			dumpcondjumpcode(codelist->code, codefile);
			break;
		case 4: dumplabel(codelist->code, file);
			dumplabelcode(codelist->code, codefile);
			break;
		case 5: dumpuncondjump(codelist->code, file);
			dumpuncondjumpcode(codelist->code, codefile);
			break;
		case 6: dumpifxrelopy(codelist->code, file);
			dumpifxrelopycode(codelist->code, codefile);
			break;
		case 7: dumpreturn(codelist->code, file);
			dumpreturncode(codelist->code, codefile);
			break;
		case 8: dumpproc(codelist->code, file);
			dumpproccode(codelist->code, codefile);
			break;
		case 9: dumpparam(codelist->code, file);
			dumpparamcode(codelist->code, codefile);
			break;
		case 10:dumpcall(codelist->code, file);
			dumpcallcode(codelist->code, codefile);
			break;
		case 11:dumpconstop(codelist->code, file);
			dumpconstopcode(codelist->code, codefile);
			break;
		case 12:dumpcallval(codelist->code, file);
			dumpcallvalcode(codelist->code, codefile);
			break;
		case 13:dumpprint(codelist->code, file);
			dumpprintcode(codelist->code, codefile);
			break;
	
	
		default:printf("Not implemented icode type %d\n",codelist->code->type);
	}}
}

%}
%union{
        char *str;
	SymbolTableEntry *ste;
	TableStack *stelist;	//Used both for scoping and for list of identifers
	Node *unode;
}
%token MODULE IDENTIFIER DEFINITION IMPLEMENTATION
%token BEG END FINALLY EXCEPT IMPORT FROM EXPORT
%token CONST TYPE VAR FORWARD PROCEDURE SET PACKEDSET POINTER TO FOR WHILE LOOP UNTIL REPEAT BY IF ELSE ELSIF DO RETURN EXIT ELLIPSIS PRINT
%token OF RETRY ARRAY CASE QUALIFIED RECORD WITH THEN RANGE VAL
%token EQ NEQ LEQ SUB GEQ SUP SETMEMBER PLUS SETUNION MINUS SETDIFF AND STRING_CONCAT MULT SETINTERSECTION
%token REALDIV SETSYMDIFF REM DIV MOD OR CASE_SEP
%token ASS_OP INTEGER_LIT REAL_LIT STRING_LIT DEREF NOT IN
%token BOOLEAN CHAR INTEGER REAL CARDINAL
%token UNARYMINUS UNARYPLUS
%%
compilation_module:	
        program_module
        |definition_module
        |implementation_module
;
program_module:
        MODULE module_identifier ';' import_lists module_block module_identifier '.'
	{
		//printf("program module parsed\n");
		if(strcmp($<ste>2->lexeme, $<ste>6->lexeme)!=0){
			printf("Error: in line %d : module name mismatch : module \" %s \" ended with module name \" %s \"\n",lineNo, $<ste>2->lexeme, $<ste>6->lexeme);
		}
		else{
		//	printf("module name: %s",$<ste>2->lexeme);
		}
	}
        ;
definition_module:
        DEFINITION MODULE module_identifier ';' import_lists definitions END module_identifier '.'
		{printf("defintiion module parsed\n");}
        ;

implementation_module:
        IMPLEMENTATION MODULE module_identifier ';' import_lists module_block module_identifier '.'
        	{printf("Implementation module parsed\n");}
	;
module_identifier:
        IDENTIFIER      
	{
		//printf("module_identifier parsed\n");
		//check if identifer already exists
		//if it does then pass its symbol table entry 
		//as synthesised attribute
		//else create one and then pass
		scope_stack->declhappening=1;
		SymbolTableEntry *iden_entry=lookup(scope_stack->top, $<str>1);
		scope_stack->declhappening=0;
		if(iden_entry==NULL){
			iden_entry=(SymbolTableEntry*)malloc(sizeof(SymbolTableEntry));
			iden_entry->lexeme=$<str>1;
			iden_entry->type=NULL;
			iden_entry->idclass=_MODULE;
			iden_entry->next=NULL;
			append(scope_stack, iden_entry);
		}
		else{
		//check if type is _MODULE
			if(iden_entry->idclass!=_MODULE){
				printf("Error: \" %s \" in line %d used as module name\n",iden_entry->lexeme, lineNo);
			}
		}
		$<ste>$=iden_entry;
	}
        ;
import_lists:
	{
	//printf("empty import list\n");
	}
        |import_lists import_list	
	{
		//printf("import list added\n");
	}
        ;
import_list:
        simple_import	
	{
		//printf("simple import parsed\n");
	}
        |unqualified_import	
	{
		//printf("unqualified import parsed\n");
	}
        ;
simple_import:
        IMPORT identifier_list ';'
	{
		TypeCons* writeproc=(TypeCons*)malloc(sizeof(TypeCons));
		$<stelist>2->top->lexeme=(char*)malloc(sizeof(char)*9);
		strcpy($<stelist>2->top->lexeme, "WriteInt");
		$<stelist>2->top->isdecl=1;
		$<stelist>2->top->type=writeproc;
		writeproc->descriptor=NULL;
		writeproc->args=(TableStack*)malloc(sizeof(TableStack));
		writeproc->args->top=(SymbolTableEntry*)malloc(sizeof(SymbolTableEntry));
		writeproc->args->top->type=IntType;
		writeproc->args->top->lexeme=(char*)malloc(sizeof(char));
		strcpy(writeproc->args->top->lexeme,"A");
		writeproc->type=TYPE_PROCEDURE;
		$<stelist>2->top->tempareasize=0;
		$<stelist>2->top->localdatasize=4;

		$<stelist>2=$<stelist>2->next;	
	if($<stelist>2!=NULL){	
		printf("added this\n");
		writeproc=(TypeCons*)malloc(sizeof(TypeCons));
		$<stelist>2->top->lexeme=(char*)malloc(sizeof(char)*9);
		strcpy($<stelist>2->top->lexeme, "WriteLn");
		$<stelist>2->top->isdecl=1;
		$<stelist>2->top->type=writeproc;
		writeproc->descriptor=NULL;
		writeproc->args=NULL;
		writeproc->type=TYPE_PROCEDURE;
		$<stelist>2->top->tempareasize=0;
		$<stelist>2->top->localdatasize=4;
		
		
		$<stelist>2=$<stelist>2->next;	

	if($<stelist>2!=NULL){	
		printf("added this too\n");
		writeproc=(TypeCons*)malloc(sizeof(TypeCons));
		$<stelist>2->top->lexeme=(char*)malloc(sizeof(char)*9);
		strcpy($<stelist>2->top->lexeme, "WriteSp");
		$<stelist>2->top->isdecl=1;
		$<stelist>2->top->type=writeproc;
		writeproc->descriptor=NULL;
		writeproc->args=NULL;
		writeproc->type=TYPE_PROCEDURE;
		$<stelist>2->top->tempareasize=0;
		$<stelist>2->top->localdatasize=4;
		

	}}
	}
        ;
unqualified_import:
        FROM module_identifier IMPORT identifier_list ';'
        ;
export_list:
        unqualified_export
        |qualified_export
        ;
unqualified_export:
        EXPORT identifier_list ';'
        ;

qualified_export:
        EXPORT QUALIFIED identifier_list ';'
        ;

identifier_list:
        qualified_identifier				
	{
		//printf("iden\t");
		$<stelist>$=(TableStack*)malloc(sizeof(TableStack));
		$<stelist>$->top=$<ste>1;
		$<stelist>$->next=NULL;
		//$<stelist>$->fromCurrentScope=1-wentout;
	//	printf("First identifier in list %s\n",$<stelist>$->top->lexeme);
	}
        |identifier_list ',' qualified_identifier
	{
	//	printf("iden added\n");
		append_list($<stelist>1, $<ste>3);
		$<stelist>$=$<stelist>1;
		//traverse($<stelist>$);
		//printf("Old top %s ",$<stelist>1->top->lexeme);
		//printf("Next indentifier in list %s\n",$<stelist>$->top->lexeme);
		//$<stelist>$->top->lexeme=strdup($<ste>3->lexeme);

	}
        ;
module_block:
        declarations2 END
	{
		//printf("module_block(no body) parsed\n");
	//	declhappening=0;
	//	printf("Decl set to 0 in module_block: declarations END\n");
		FILE* fc=fopen("code.s","w");
		FILE* fic=fopen("icode","w");
		//if($<unode>1->code==NULL)printf("no code to generate");
		fprintf(fc,"\t.data\nspace:\t.asciiz \" \"\nstr:\t.asciiz \"\\n\"\n\t.text\n\t.globl main\nmain:");
		fprintf(fc,"\tmove $fp, $sp\n");
		fprintf(fc,"\taddi $sp, $sp, -%d\n",addr+tempareasize);
		fprintf(fc, "#add: %d #tempareasize\n",addr,tempareasize);
		dumpicode($<unode>$->code, fic, fc);
		fprintf(fc,"WriteInt:\n\tlw $a0, 0($sp)\n\tli $v0, 1\n\tsyscall\n");
		fprintf(fc,"\taddi $sp, $sp, 12\n\tlw $fp, -4($sp)\n\tjr $ra\n");
		
		fprintf(fc,"WriteLn:\n");
		fprintf(fc,"\tli $v0, 4\n\tla $a0, str\n\tsyscall\n\taddi $sp, $sp, 12\n\tlw $fp, -4($sp)\n\tjr $ra\n");
		
		fprintf(fc,"WriteSp:\n");
		fprintf(fc,"\tli $v0, 4\n\tla $a0, space\n\tsyscall\n\taddi $sp, $sp, 12\n\tlw $fp, -4($sp)\n\tjr $ra\n");
		
		close(fic);
		close(fc);
	}
        |declarations2 module_body END
 	{
		
	//	printf("module_block parsed\n");
	
		//Quad* newquad=(Quad*)malloc(sizeof(Quad));
		//newquad->type=13;
		//dumpicode(list, stdout, stdout);

	//	$<unode>$=(Node*)malloc(sizeof(Node));
		//printf("module block\n");
//		dumpicode($<unode>2->code, stdout, stdout);
		//printf("end\n");	
		//printf("procedure block\n");
		//dumpicode($<unode>1->code, stdout, stdout);
		//printf("end\n");	
		if($<unode>1->code!=NULL){
		    if($<unode>2->code!=NULL){
			$<unode>$->code=append_codelists($<unode>2->code,$<unode>1->code);
		    }
		    else{
			$<unode>$->code=$<unode>1->code;
		    }
		}
		else{
		    if($<unode>2->code!=NULL){
			$<unode>$->code=$<unode>2->code;
		    }
		    else{
			$<unode>$->code=NULL;
		    }
		}
		//$<unode>$->code=append_line_to_list($<unode>$->code, newquad);
		addr=scope_stack->offset+scope_stack->width;
		if($<unode>$==NULL)printf("Got null node");
		FILE* fc=fopen("code.s","w");
		FILE* fic=fopen("icode","w");
		if($<unode>$->code==NULL)printf("no code to generate");
		tempareasize=tempcount*4+4;
		fprintf(fc, "#add: %d #tempareasize %d\n",addr,tempareasize);
		fprintf(fc,"\t.data\nspace:\t.asciiz \" \"\nstr:\t.asciiz \"\\n\"\n\t.text\n\t.globl main\nmain:");
		//fprintf(fc,"\t.data\nstr:\t.asciiz \"\\n\"\n\t.text\n\t.globl main\nmain:");
		fprintf(fc,"\tmove $fp, $sp\n");
		fprintf(fc,"\taddi $sp, $sp, -%d\n",addr+tempareasize);
		dumpicode($<unode>$->code, fic, fc);

	
		close(fic);
		fprintf(fc,"\tli $v0, 10\n");
       		fprintf(fc,"\tsyscall\n");
		fprintf(fc,"\n#END MAIN\n\n");

		fprintf(fc,"WriteInt:\n\tlw $a0, 0($sp)\n\tli $v0, 1\n\tsyscall\n");
		fprintf(fc,"\taddi $sp, $sp, 12\n\tlw $fp, -4($sp)\n\tjr $ra\n");
		
		fprintf(fc,"WriteLn:\n");
		fprintf(fc,"\tli $v0, 4\n\tla $a0, str\n\tsyscall\n\taddi $sp, $sp, 12\n\tlw $fp, -4($sp)\n\tjr $ra\n");
		
		fprintf(fc,"WriteSp:\n");
		fprintf(fc,"\tli $v0, 4\n\tla $a0, space\n\tsyscall\n\taddi $sp, $sp, 12\n\tlw $fp, -4($sp)\n\tjr $ra\n");
	

//		fprintf(fc,"WriteInt:\n\tlw $a0, 0($sp)\n\tli $v0, 1\n\tsyscall\n");
//		fprintf(fc,"\tli $v0, 4\n\tla $a0, str\n\tsyscall\n\taddi $sp, $sp, 12\n\tlw $fp, -4($sp)\n\tjr $ra\n");
		close(fc);
		//close(f);
	}
        ;
declarations2:
	declarations
	{
		scope_stack->declhappening=0;
	}
declarations:
	{
//		printf("1. Setting decl 0\n");
		$<unode>$=(Node*)malloc(sizeof(Node));
		$<unode>$->code=NULL;
	}
        |declarations declaration
	{
//		printf("2. Setting decl 0\n");
		$<unode>$=(Node*)malloc(sizeof(Node));
		if($<unode>1->code!=NULL){
		    if($<unode>2->code!=NULL){
			$<unode>$->code=append_codelists($<unode>1->code,$<unode>2->code);
		    }
		    else{
			$<unode>$->code=$<unode>2->code;
		    }
		}
		else{
		    if($<unode>2->code!=NULL){
			$<unode>$->code=$<unode>2->code;
		    }
		    else{
			$<unode>$->code=NULL;
		    }
		}
		
	}
        ;
declaration:
        CONST c_list
	{
	//	printf("constant declaration parsed\n");
		$<unode>$=(Node*)malloc(sizeof(Node));
		$<unode>$->code=NULL;
	}
        |TYPE t_list	
	{
	//	printf("type declaration parsed\n");
		$<unode>$=(Node*)malloc(sizeof(Node));
		$<unode>$->code=NULL;
	}
        |VAR v_list
	{
	//	printf("variable declaration parsed\n");
		$<unode>$=(Node*)malloc(sizeof(Node));
		$<unode>$->code=NULL;
		scope_stack->width=addr;//-scope_stack->offset;
		
	}
        |procedure_declaration ';'
	{
	//	printf("procedure declaartion parsed\n");
		if($<unode>1!=NULL){
			$<unode>$=$<unode>1;
		}
		else{
			$<unode>$=(Node*)malloc(sizeof(Node));
			$<unode>$->code=NULL;
		}
	}
	|local_module_declaration ';'
	{
	//	printf("local module declaration parsed\n");
		$<unode>$=(Node*)malloc(sizeof(Node));
		$<unode>$->code=NULL;
	}
	;
local_module_declaration:
        MODULE module_identifier ';' import_lists module_block module_identifier
        |MODULE module_identifier ';' import_lists export_list module_block module_identifier
        ;
definitions: /*eMpTy*/
        |definitions definition	
	{
	//	printf("definition added\n");
	}
        ;

definition:
        CONST c_list		
	{
	//	printf("constant definition parsed\n");
	}
        |TYPE t_list
	{
	//	printf("type definition parsed\n");
	}
        |VAR v_list
	{
	//	printf("variable definition parsed\n");
	}
        |procedure_heading ';'
	{
	//	printf("procedure definiton parsed\n");
	}
        ;
procedure_heading:
        proper_procedure_heading	
	{
	//	printf("proper procedure heading parsed\n");
	}
        |function_procedure_heading
	{
	//	printf("function procedure heading parsed\n");
	}
        ;

c_list:	/*eMpTy*/
        | c_list constant_declaration ';'
	{
	//	printf("const decl added\n");
		$<unode>$=NULL;
	}
        ;		
t_list:	/*eMpTy*/	
        | t_list type_definition ';'
	{
	//	printf(" type def added\n");
		$<unode>$=NULL;
	}
        ;
v_list:	/*eMpTy*/
        | v_list variable_declaration ';'
	{
	//	printf("variable def parsed\n");
		$<unode>$=NULL;
	}
        ;
type_definition:
        type_declaration
        |opaque_type_definition
        ;
opaque_type_definition:
        qualified_identifier
	{
		//what to do?
	}
        ;
type_declaration:
        qualified_identifier '=' type_denoter
	{
		//check if not already declared
		//unode
		$<ste>1->type=$<unode>3->type;
                $<ste>1->isdecl=1;
                $<ste>1->type->name=$<ste>1->lexeme;
        	tempcount=-1;
	  //    printf("isdeclare=1\n");
                //unode
	}
	;

variable_declaration:
        identifier_list ':' type_denoter
	{
	//	printf("variable_decl\n");
		//printf("Top of stack %s \n ",$<stelist>1->top->lexeme);
		//printf("%d\n",$<stelist>1->top->type->type);
		//need to go over the whole list and assign types
		assign_types($<stelist>1, $<unode>3);
		//printf("Size of variable %d\n",$<unode>3->type->size);
		$<unode>$=NULL;
		tempcount=-1;
	}
        ;
procedure_declaration:
        proper_procedure_declaration
	{
	//	printf("proper procedure declarartion\n");
		$<unode>$=(Node*)malloc(sizeof(Node));
		Quad* newquad=(Quad*)malloc(sizeof(Quad));
		newquad->type=7;
		newquad->switch1=0;
		newquad->arg1=NULL;
		//newquad->width=RETURN_WIDTH;
		//newquad->offset=$<unode>1->offset+$<unode>1->width;
		$<unode>$->code=append_line_to_list($<unode>1->code,newquad);
	}
        |function_procedure_declaration	
	{
		//printf("function procedure declaration\n");
	//	printf("function procedure declarartion\n");
                $<unode>$=(Node*)malloc(sizeof(Node));
               $<unode>$->code=$<unode>1->code;
		//printf("parsed function\n");
		//dumpicode($<unode>$->code, stdout, stdout);
		//printf("end\n");
		// Quad* newquad=(Quad*)malloc(sizeof(Quad));
               // newquad->type=7;
		//newquad->switch1=1;
		//newquad->arg1=$<unode>1->;//
                //newquad->width=RETURN_WIDTH;
                //newquad->offset=$<unode>1->offset+$<unode>1->width;
                //$<unode>$->code=append_line_to_list($<unode>1->code,newquad);

	}
        ;

proper_procedure_declaration:
        proper_procedure_heading ';' proc_body
	{
	//	printf("ppd\n");
		$<unode>$=(Node*)malloc(sizeof(Node));
		$<unode>$->code=append_codelists($<unode>1->code, $<unode>3->code);
	}
        ;
proc_body:
        proper_procedure_block procedure_identifier_end
	{
	//	printf("proc body\n");
		$<unode>$=$<unode>1;
		$<ste>2->localdatasize=addr;
		addr=0;
		$<ste>2->tempareasize=4+tempcount*4;
		tempcount=-1;
	}
        |FORWARD
	;
procedure_identifier_end:
	qualified_identifier
	{
	//	printf("procedure identifier end\n");
                $<ste>$=$<ste>1;
	}
procedure_identifier:
        qualified_identifier	
	{
	//	printf("procedure identifier start\n");
		$<ste>$=$<ste>1;
		$<ste>$->isdecl=1;
	/*	if($<ste>$->type->type!=TYPE_PROCEDURE){
			printf("Error: in line %d: procedure %s not defined\n", lineNo, $<ste>$->lexeme);
			$<ste>$->type=ErrorType;
		}*/
		
	//	printf("#############################################Pushing new scope\n");
		TableStack* newscope=(TableStack*)malloc(sizeof(TableStack));
		if(scope_stack->next!=NULL){
			printf("Wrong!!");
			scope_stack->next=NULL;
		}
		newscope->next= scope_stack;
		newscope->top=NULL;
		$<ste>$->scope=newscope;
		scope_stack=newscope;
		scope_stack->declhappening=1;
	//	printf("1. Setting decl 1\n");
		addr=0;
		tempcount=-1;
		printf("Reset addr for procedure %s\n",$<ste>$->lexeme);
	}
        ;

proper_procedure_heading:
        PROCEDURE procedure_identifier
	{
	//	printf("heading parsed\n");
		//printf("In proc heading: procedurename received %s\n",$<ste>2->lexeme);
		$<ste>2->type=(TypeCons*)malloc(sizeof(TypeCons));
		$<ste>2->type->type=TYPE_PROCEDURE;
		$<ste>2->type->descriptor=NULL;
		$<ste>2->type->args=NULL;
		//$<ste>2->localdatasize=0;
		$<unode>$=(Node*)malloc(sizeof(Node));
		$<unode>$->type=VoidType;
	//	if(temp->type==NULL)printf("Error4");
	//	else printf("AAL IZZ WELL\n");
		
		Quad* newquad=(Quad*)malloc(sizeof(Quad));
		newquad->type=8;	//put label
		newquad->arg1=$<ste>2;
		newquad->width=0;
		newquad->offset=0;
		Icode* newlist=(Icode*)malloc(sizeof(Icode));
		newlist->next=NULL;
		newlist->code=newquad;
		$<unode>$->code=newlist;
		//$<ste>2->label=labelcount;
	}
        |PROCEDURE procedure_identifier formal_parameters
	{
	//	printf("heading parsed\n");
		//printf("In proc heading: procedurename received %s\n",$<ste>2->lexeme);
                $<ste>2->type=(TypeCons*)malloc(sizeof(TypeCons));
                $<ste>2->type->type=TYPE_PROCEDURE;
                $<ste>2->type->descriptor=NULL;
		$<ste>2->type->args=$<stelist>3;
                $<unode>$=(Node*)malloc(sizeof(Node));
                $<unode>$->type=VoidType;
		Quad* newquad=(Quad*)malloc(sizeof(Quad));
		newquad->type=8;	//put label
		newquad->arg1=$<ste>2;
		Icode* newlist=(Icode*)malloc(sizeof(Icode));
		newlist->next=NULL;
		newlist->code=newquad;
		$<unode>$->code=newlist;
		$<unode>$->width=0;

	}
        ;
proper_procedure_block:
        declarations2 END
	{
	//	printf("proper procedure block\n");
	//	printf("#############################################Popping scope stack\n");
		scope_stack->tempareasize=4+tempcount*4;
		scope_stack=scope_stack->next;
		//tempcount=-1;
		$<unode>$=NULL;
	}
        |declarations2 procedure_body END
	{
	//	printf("proper procedure with body block\n");
		//printf("Popping scope stack\n");
	//	printf("#############################################Popping scope stack\n");
		


		scope_stack->tempareasize=4+tempcount*4;
		scope_stack=scope_stack->next;
		$<unode>$=$<unode>2;
		//tempcount=-1;
		
	}
        ;
procedure_body:
        BEG block_body
	{
		//printf("procedure body\n");
		$<unode>$=$<unode>2;
	}
        ;
formal_parameters:
        '(' ')'	
	{
	//	printf("empty formal parameters\n");
		$<stelist>$=NULL;
	}
        |'(' formal_parameter_list ')'
	{
	//	printf("formal parameters parsed\n");
		$<stelist>$=$<stelist>2;
	}
        ;
formal_parameter_list:
        f_list	
	{
		$<stelist>$=$<stelist>1;
	}
        ;
f_list: formal_parameter
	{
		$<stelist>$=$<stelist>1;
		//printf("F param Type %d\n", $<stelist>$->top->type->type);
	}
        |f_list ';' formal_parameter
	{
		//printf("formal parameter added\n");
		append_lists($<stelist>1, $<stelist>3);
		$<stelist>$=$<stelist>1;
		//printf("F param Type %d\n", $<stelist>$->top->type->type);

	}
        ;
formal_parameter:
        value_parameter_specification
	{
		//printf("formal_param\n");
		$<stelist>$=$<stelist>1;
	}
        |variable_parameter_specification
	{
		$<stelist>$=$<stelist>1;
	}
	;
value_parameter_specification:
        identifier_list ':' formal_type
	{
		//printf("vps\n");
		assign_types($<stelist>1,$<unode>3);
		$<stelist>$=$<stelist>1;
	}
        ;
variable_parameter_specification:
        VAR identifier_list ':' formal_type{
		assign_types($<stelist>2, $<unode>4);
		$<stelist>$=$<stelist>2;
	}
	;
formal_type:
        type_identifier
        |open_array_formal_type ;


open_array_formal_type:
        ARRAY OF open_array_component_type
        ;
open_array_component_type:
        formal_type ;
function_procedure_declaration:
        function_procedure_heading ';' func_proc_body
	{
		//printf("function procedure declaration");
	//	printf("fpd\n");
                $<unode>$=(Node*)malloc(sizeof(Node));
                $<unode>$->code=append_codelists($<unode>1->code, $<unode>3->code);
		$<unode>$->returntype=$<unode>1->returntype;
		//printf("return type1: %d\n",$<unode>1->returntype->type);
		//printf("return type2: %d\n",returntype->type);
		
		if(!isEqual(returntype, $<unode>1->returntype)){
			printf("Error: in line %d return type mismatch\n", lineNo);
		}
		returntype=NULL;
	}
        ;
func_proc_body:
        function_procedure_block procedure_identifier_end 
        {
	//	printf("proc body\n");
		$<unode>$=$<unode>1;
	//	printf("in func_proc_body\n");
	//	dumpicode($<unode>$->code, stdout, stdout);
	//	printf("code ends\n");
	
		$<ste>2->localdatasize=addr;
		printf("Procedure %s: Local Data : %d, Temporary space %d\n",$<ste>2->lexeme, addr,4+tempcount*4);
		addr=0;
		$<ste>2->tempareasize=4+tempcount*4;
		tempcount=-1;
	}
	|FORWARD
        ;
function_procedure_heading:
        PROCEDURE procedure_identifier formal_parameters ':' function_result_type
        {//	printf("heading parsed\n");
		//printf("In proc heading: procedurename received %s\n",$<ste>2->lexeme);
                $<ste>2->type=(TypeCons*)malloc(sizeof(TypeCons));
                $<ste>2->type->type=TYPE_PROCEDURE;
                $<ste>2->type->descriptor=$<unode>5->type;
		$<ste>2->type->args=$<stelist>3;
                $<unode>$=(Node*)malloc(sizeof(Node));
                $<unode>$->type=VoidType;
		Quad* newquad=(Quad*)malloc(sizeof(Quad));
		newquad->type=8;	//put label
		newquad->arg1=$<ste>2;
		Icode* newlist=(Icode*)malloc(sizeof(Icode));
		newlist->next=NULL;
		newlist->code=newquad;
		$<unode>$->code=newlist;
		$<unode>$->width=0;
		$<unode>$->returntype=$<unode>5->type;
	}
	;

function_result_type:
        type_identifier ;

function_procedure_block:
        declarations2 function_body END 
	{
		scope_stack->tempareasize=4+tempcount*4;
		scope_stack=scope_stack->next;
		$<unode>$=$<unode>2;
	}
	;
function_body:
        BEG block_body 
	{
		//printf("procedure body\n");
		$<unode>$=$<unode>2;
	//	if($<unode>$->code!=NULL)printf("###id:%d\n",$<unode>$->code->code->arg1temp);
	//	printf("end of block body %d\n",tempcount);
	}
	;

type_denoter:
	type_identifier	
	{
		$<unode>$=$<unode>1;
		//printf("Type identifier intercepted\n");
	}
        |new_type	
	{
		//$<unode>$=(Node*)malloc(sizeof(Node));
		printf("-----------new type--------------:%d", $<unode>1->type->type);
		if($<unode>1->type->descriptor!=NULL){
			printf("of %d\n",$<unode>1->type->descriptor->type);
		}
		//$<unode>$->type=NULL;
		$<unode>$=$<unode>1;
		
	}
        ;
basic_type:
	BOOLEAN		
	{
		////printf("boolean\n");
		$<unode>$=(Node*)malloc(sizeof(Node));
		$<unode>$->type=BooleanType;
	}
	|CHAR
	{
                ////printf("boolean\n");
                $<unode>$=(Node*)malloc(sizeof(Node));
                $<unode>$->type=CharType;
        }
	|INTEGER	
	{	
                ////printf("boolean\n");
                $<unode>$=(Node*)malloc(sizeof(Node));
                $<unode>$->type=IntType;
        }
	|CARDINAL	
	{
                ////printf("boolean\n");
                $<unode>$=(Node*)malloc(sizeof(Node));
                $<unode>$->type=CardinalType;
        }
	|REAL		
	{
                ////printf("boolean\n");
                $<unode>$=(Node*)malloc(sizeof(Node));
                $<unode>$->type=RealType;
        }
	;
type_identifier:
	basic_type
	{
		TypeCons* copy =(TypeCons*)malloc(sizeof(TypeCons));
		copy->type=$<unode>1->type->type;
		copy->size=$<unode>1->type->size;
		$<unode>$->type=copy;
	
	}
	|qualified_identifier
	{
	//	printf("No error before this\n");
         //       printf("type:%d", $<ste>1->type->type);
                $<unode>$=(Node*)malloc(sizeof(Node));
       //         printf("lexeme%s\n",$<ste>1->lexeme);
       //         printf("isdecl%d\n",$<ste>1->isdecl);
                $<unode>$->type=$<ste>1->type;
         //       printf("Parsed type identifier succesfully\n");
                //$<ste>$->idclass=_TYPE;
	} 
	;
new_type:
        new_ordinal_type
        |set_type		
	{
		//printf("set type parsed\n");
	}
        |packedset_type		
	{
		//printf("packed set type parsed\n");
	}
        |pointer_type	
	{
		//printf("pointer type parsed\n");
	}
        |procedure_type
	{	
		//printf("procedure type parsed\n");
	}
        |array_type
	{//printf("array type parsed\n");
	}
        |record_type
	{
	//	printf("record type parsed\n");
	}
        ;

new_ordinal_type:
        enumeration_type
	{
		//printf("Enum parsed\n");
	}
        |subrange_type
	{
		//printf("Subrange parsed\n");
	}
        ;
enumeration_type:
        '(' identifier_list ')'
	{
		TypeCons* newenum=(TypeCons*)malloc(sizeof(TypeCons));
		newenum->args=$<stelist>2;
		newenum->size=lengthoflist($<stelist>2)*4;
		$<unode>$=(Node*)malloc(sizeof(Node));
		$<unode>$->type=newenum;
	}
        ;
subrange_type:
        '[' constant_expression ELLIPSIS constant_expression ']'
	{
		$<unode>$=(Node*)malloc(sizeof(Node));
		//if(isEqual($<unode>2->type,ZType) && isEqual($<unode>4->type,ZType))
		if($<unode>2->isConst==1 && $<unode>4->isConst==1){
		
			TypeCons* newtype=(TypeCons*)malloc(sizeof(TypeCons));
			newtype->type=TYPE_SUBRANGE;
			newtype->d1=$<unode>2->valint;
			newtype->d2=$<unode>4->valint;
			newtype->size=newtype->d2-newtype->d1+1;
			$<unode>$->type=newtype;
		}
		else{
			printf("Error: in line %d: Invalid array index\n", lineNo);
			$<unode>$->type=ErrorType;
		}
	}
        |range_type '[' constant_expression ELLIPSIS constant_expression ']'
	{
	//	printf("Should not have come here: range_type subrange not implemented\n");
	}
        ;

range_type:
        ordinal_type_identifier
        ;
ordinal_type_identifier:
        type_identifier
	;
base_type:
        ordinal_type_denoter ;

ordinal_type_denoter:
        ordinal_type_identifier
        |new_ordinal_type
        ;

set_type:
        SET OF base_type
        ;

packedset_type:
        PACKEDSET OF base_type ;

pointer_type:
        POINTER TO bound_type ;

bound_type:
        type_denoter
	{
		$<unode>$=$<unode>1;
	}
	;
procedure_type:
        proper_procedure_type
        |function_procedure_type
        ;
proper_procedure_type:
        PROCEDURE
        |PROCEDURE '(' ')'
        |PROCEDURE '(' formal_parameter_type_list ')'
        ;

function_procedure_type:
        PROCEDURE '(' ')' ':' function_result_type
        |PROCEDURE '(' formal_parameter_type_list ')' ':' function_result_type
        ;
formal_parameter_type_list:
        formal_parameter_type
        |formal_parameter_type_list ',' formal_parameter_type
        ;

formal_parameter_type:
        variable_formal_type
        |value_formal_type
        ;
variable_formal_type:
        VAR formal_type ;

value_formal_type:
        formal_type ;

array_type:
        ARRAY index_type_list OF component_type
	{
		TypeCons* newarray=(TypeCons*)malloc(sizeof(TypeCons));
		newarray->type=TYPE_ARRAY;
		if(!isEqual($<unode>4->type,ErrorType) && !isEqual($<unode>2->type,ErrorType)){
			newarray->descriptor=$<unode>4->type;
			int length=lengthof($<unode>2);
			//printf("Length : %d\n",length);
			newarray->index=(TypeCons**)malloc(sizeof(TypeCons*)*length);
			newarray->dims=length;
			fill_array_index_dims(newarray->index, $<unode>2);
			newarray->size=$<unode>2->size*$<unode>4->type->size;
			printf("Declared %d dimensional array of type %d\n",newarray->dims,$<unode>4->type->type);
		if(newarray->index==NULL)printf("NULL in array_type\n");	
			$<unode>$=(Node*)malloc(sizeof(Node));
			$<unode>$->type=newarray;
			
		}
		else{
			$<unode>$->type=ErrorType;
		}
	}
        ;

index_type_list:
        index_type
	{
		$<unode>$=$<unode>1;
		$<unode>$->size=$<unode>1->type->size;
	//	printf("Size : %d\n",$<unode>1->type->size);
	}
        |index_type_list ',' index_type
	{
		//printf("Should not have printed this: long index_list\n");
		$<unode>$=append_at_end($<unode>1, $<unode>3);
		$<unode>$->size=$<unode>1->size*$<unode>3->type->size;
	}
        ;
index_type:
        ordinal_type_denoter ;

component_type:
        type_denoter
	{
		$<unode>$=$<unode>1;
	}
	;

record_type:
        RECORD field_list END
	{
	//	printf("Records parse start\n");

                TypeCons* newrecord=(TypeCons*)malloc(sizeof(TypeCons));
                newrecord->type=TYPE_RECORD;
                newrecord->descriptor=$<unode>2->type;
		//printf("%d\n",$<unode>2->type->offset_in_record);
                $<unode>$=(Node*)malloc(sizeof(Node));
                $<unode>$->type=newrecord;
		$<unode>$->type->size=$<unode>2->type->offset_in_record + $<unode>2->type->size;
		//$<unode>$->type->size=global_rec_offset + $<unode>2->type->size;
                //global_rec_offset=0;
		//printf(" %d Record parsed Size : %d\n", $<unode>2->type->offset_in_record, $<unode>$->type->size);

	}
        ;

field_list:
	fields
        {
                $<unode>$=$<unode>1;
                $<unode>$->next=NULL;
		$<unode>$->type->offset_in_record=0;
        }
        |field_list ';' fields
        {
       //         printf("filed_list\n");



                /*if($<unode>3==NULL)printf("error2");
                else printf(" no error ");
                if($<unode>1==NULL)printf("error1");
                else printf(" no error ");

                if($<unode>3->type==NULL)printf("error!!!!");
                else printf(" no error ");
                */
                if($<unode>3!=NULL){
                $<unode>3->type->next=$<unode>1->type;
		$<unode>3->type->offset_in_record=$<unode>1->type->offset_in_record+$<unode>1->type->size;
                $<unode>$=$<unode>3;
		//global_rec_offset=$<unode>3->type->offset_in_record;
		//printf("global %d\n",global_rec_offset);
                //printf("filed_list offset %d size %d\n", $<unode>$->type->offset_in_record, $<unode>$->type->size);

//              printf("filed_list end\n");
                }
                else{
		//	printf("wrong\n");
                        $<unode>$=$<unode>1;
		//	$<unode>$->type->offset_in_record=0;
                }
        }
	;
fields: {
		$<unode>$=NULL;
	}
        |fixed_fields 		{//printf("fixed field\n");
	}
	|variant_fields		{//printf("variant_field\n");
	}
	;
variant_fields:
        CASE tag_field OF variant_list END
        ;
tag_field:
        ':' tag_type
        |tag_identifier ':' tag_type
        ;

tag_identifier:
        qualified_identifier
	{
		$<ste>$=$<ste>1;
		//check type
	}
	;

tag_type:
        ordinal_type_identifier ;

variant_list:
        variant csv_list
        |variant csv_list variant_else_part
        ;

csv_list:
        |csv_list '|' variant
        ;
variant_else_part:
        ELSE field_list ;

variant:/*eMpTy*/
        |variant_label_list ':' field_list
        ;
variant_label_list:
        variant_label
        |variant_label_list ',' variant_label
        ;

variant_label:
        constant_expression
        |constant_expression ELLIPSIS constant_expression
        ;


fixed_fields:
        identifier_list ':' field_type
	{
	 	$<unode>$=(Node*)malloc(sizeof(Node));
        //        traverse_identifier_list($<stelist>1);
                TypeCons* copy=(TypeCons*)malloc(sizeof(TypeCons));
                copy->type=$<unode>3->type->type;
                copy->d1=$<unode>3->type->d1;
                copy->d2=$<unode>3->type->d2;
                copy->dims=$<unode>3->type->dims;
                copy->descriptor=$<unode>3->type->descriptor;
                copy->args=$<unode>3->type->args;
                copy->index=$<unode>3->type->index;
                copy->next=$<unode>3->type->next;
                copy->name=$<stelist>1->top->lexeme;
                copy->size=$<unode>3->type->size;
		$<unode>$->type=copy;
		
        //        printf("\n\ntype of feild type assigned\n\n\n");
	}
field_type:
        type_denoter
	{
		$<unode>$=$<unode>1;
	}
	;

constant_declaration:
        qualified_identifier '=' constant_expression
	{
		//no type check needed	
		$<unode>$=(Node*)malloc(sizeof(Node));
		if(!isEqual($<unode>3->type ,ErrorType)){
			$<unode>$->type=ErrorType;
		}
		else{
			$<unode>$->type=ErrorType;
		}
	}
        ;
constant_expression:
        expression 
	{
		$<unode>$=$<unode>1;
	//	printf("isConst: %d\n",$<unode>$->isConst);
	}
	;
expression:
        simple_expression	
	{
		$<unode>$=$<unode>1;
	}
        |simple_expression relational_operator simple_expression
	{
		$<unode>$=(Node*)malloc(sizeof(Node));
		$<unode>$->type = BooleanType;
		$<unode>$->isConst=0;
		tempcount++;
		$<unode>$->tempid=tempcount;
	/*	if($<unode>1->tempid>=0 && $<unode>3->tempid>=0){
			fprintf(intercode, "%d: t%d:=t%d %s t%d\n",lineNo,tempcount,$<unode>1->tempid, $<str>2, $<unode>3->tempid);
		}
		else if($<unode>1->tempid<0 && $<unode>3->tempid>=0){
			
			fprintf(intercode, "%d : t%d:=%s %s t%d\n",lineNo,tempcount,$<unode>1->ste->lexeme, $<str>2, $<unode>3->tempid);
		}
		else if($<unode>1->tempid>=0 && $<unode>3->tempid<0){
			fprintf(intercode, "%d : t%d:=t%d %s %s\n",lineNo,tempcount,$<unode>1->tempid, $<str>2, $<unode>3->ste->lexeme);
		}
		else{
			fprintf(intercode, "%d : t%d:=%s %s %s\n",lineNo,tempcount,$<unode>1->ste->lexeme, $<str>2, $<unode>3->ste->lexeme);
		}
*/
		Quad* newquad=(Quad*)malloc(sizeof(Quad));
		newquad->type=6;	//if x relop y
		newquad->op=strdup($<str>2);
		labelcount++;
		newquad->label=labelcount;
		if($<unode>1->tempid>=0){
			newquad->switch1=1;
			newquad->arg1temp=$<unode>1->tempid;
		}
		else{
			newquad->switch1=0;
			newquad->arg1=$<unode>1->ste;
		}
		
		if($<unode>3->tempid>=0){
		
			newquad->switch2=1;
			newquad->arg2temp=$<unode>3->tempid;
		}
		else{
			newquad->switch2=0;
			newquad->arg2=$<unode>3->ste;
		}
		addicode(newquad);
		
		if($<unode>1->code==NULL){
	//		printf("got null code in relational expression");
			if($<unode>3->code==NULL){
			Icode* newcode=(Icode*)malloc(sizeof(Icode));	
			newcode->next=NULL;
			newcode->code=newquad;
			$<unode>$->code=newcode;
			}
			else{
			$<unode>$->code=append_line_to_list($<unode>3->code, newquad);
			}
		}
		else{
			if($<unode>3->code!=NULL){
			$<unode>$->code=append_codelists($<unode>1->code, $<unode>3->code);
			$<unode>$->code=append_line_to_list($<unode>$->code, newquad);
			}
			else{
			$<unode>$->code=append_line_to_list($<unode>1->code, newquad);
			}
		}

		newquad=(Quad*)malloc(sizeof(Quad));
		newquad->type=2;	// x=0 copy constant
		
		newquad->switch3=1;
		newquad->restemp=tempcount;
		newquad->typeofconst=TYPE_INT;
		newquad->str=(char*)malloc(sizeof(char)*2);
		strcpy(newquad->str,"0");
		
		addicode(newquad);
		$<unode>$->code=append_line_to_list($<unode>$->code, newquad);
		
		newquad=(Quad*)malloc(sizeof(Quad));
		newquad->type=5;	//unconditional jump
		newquad->label=++labelcount;
		$<unode>$->code=append_line_to_list($<unode>$->code, newquad);
		
		
		newquad=(Quad*)malloc(sizeof(Quad));
		newquad->type=4;	//put label
		newquad->label=labelcount-1;
		$<unode>$->code=append_line_to_list($<unode>$->code, newquad);
		
		newquad=(Quad*)malloc(sizeof(Quad));
		newquad->type=2;	// x=1 copy constant
		newquad->switch3=1;
		newquad->restemp=tempcount;
		newquad->typeofconst=TYPE_INT;
		newquad->str=(char*)malloc(sizeof(char)*2);
		strcpy(newquad->str,"1");
		$<unode>$->code=append_line_to_list($<unode>$->code, newquad);
		
		newquad=(Quad*)malloc(sizeof(Quad));
		newquad->type=4;	//put label
		newquad->label=labelcount;
		$<unode>$->code=append_line_to_list($<unode>$->code, newquad);
//		printf("Dumping bool \n");
		//dumpicode($<unode>$->code, stdout);
//		printf("Dumping bool ends\n");
	}
        ;
simple_expression:
	term
	{
		$<unode>$=$<unode>1;
	}
	|sign term
	{
		$<unode>$=$<unode>1;
	}
	|simple_expression term_operator term
	{
//		printf("simple expression parsed\t");
                $<unode>$=(Node*)malloc(sizeof(Node));
                if($<unode>1 !=NULL){
			$<unode>$->isConst=0;
			if(isProperType($<unode>1->type) && isProperType($<unode>3->type)){
                        	if(isEqual($<unode>3->type, $<unode>1->type)){
                               	 $<unode>$->type=$<unode>3->type;
                        	}
                        	else{
                                    $<unode>$->type = ErrorType;
                                    printf("Error: in line %d : incompatible types\n", lineNo);
                        	}
                	}
                	else if(isEqual($<unode>3->type,ErrorType)||isEqual($<unode>1->type,ErrorType)){
                        	$<unode>$->type = ErrorType;
                	}
			else{
				//$<unode>$->type = $<unode>1->type;
//				printf("*******************Check out**\n");
				$<unode>$ = $<unode>1;
			}
		}
                else {
			//$<unode>$->type = $<unode>1->type;
			$<unode>$=$<unode>1;
		}
     
		tempcount++;
		$<unode>$->tempid=tempcount;
		if($<unode>1->tempid>=0 && $<unode>3->tempid>=0){
			fprintf(intercode, "%d : t%d:=t%d %s t%d\n",lineNo,tempcount,$<unode>1->tempid, $<str>2, $<unode>3->tempid);
		}
		else if($<unode>1->tempid<0 && $<unode>3->tempid>=0){
			
			fprintf(intercode, "%d : t%d:=%s %s t%d\n",lineNo,tempcount,$<unode>1->ste->lexeme, $<str>2, $<unode>3->tempid);
		}
		else if($<unode>1->tempid>=0 && $<unode>3->tempid<0){
			fprintf(intercode, "%d : t%d:=t%d %s %s\n",lineNo,tempcount,$<unode>1->tempid, $<str>2, $<unode>3->ste->lexeme);
		}
		else{
			fprintf(intercode, "%d : t%d:=%s %s %s\n",lineNo,tempcount,$<unode>1->ste->lexeme, $<str>2, $<unode>3->ste->lexeme);
		}




		Quad* newquad=(Quad*)malloc(sizeof(Quad));
		newquad->type=0;	//Assignment icode type
		newquad->op=strdup($<str>2);
		newquad->restemp=tempcount;
		newquad->switch3=1;
		if($<unode>1->tempid>=0){
			newquad->switch1=1;
			newquad->arg1temp=$<unode>1->tempid;
		}
		else{
			newquad->switch1=0;
			newquad->arg1=$<unode>1->ste;
		}
		
		if($<unode>3->tempid>=0){
		
			newquad->switch2=1;
			newquad->arg2temp=$<unode>3->tempid;
		}
		else{
			newquad->switch2=0;
			newquad->arg2=$<unode>3->ste;
		}
		addicode(newquad);


		if($<unode>1->code==NULL){
//			printf("got null code in simple expression");
			if($<unode>3->code==NULL){
			Icode* newcode=(Icode*)malloc(sizeof(Icode));	
			newcode->next=NULL;
			newcode->code=newquad;
			$<unode>$->code=newcode;
			}
			else{
			$<unode>$->code=append_line_to_list($<unode>3->code, newquad);
			}
		}
		else{
			if($<unode>3->code!=NULL){
			$<unode>$->code=append_codelists($<unode>1->code, $<unode>3->code);
			$<unode>$->code=append_line_to_list($<unode>$->code, newquad);
			}
			else{
			$<unode>$->code=append_line_to_list($<unode>1->code, newquad);
			}
		}
	}
       ;
sign:
	'+'	{$<str>$=strdup($<str>1);}
	|'-'	{$<str>$=strdup($<str>1);}
	;
term:
	factor
	{
		$<unode>$=$<unode>1;
		//$<unode>$->code=NULL;
	}
	|term factor_operator factor
	{
//		printf("term parsed\t");
		$<unode>$=(Node*)malloc(sizeof(Node));
		if($<unode>1 !=NULL){
//		printf("term not null\n");
		$<unode>$->isConst=0;
		if(isProperType($<unode>1->type )){
			$<unode>$->isConst=0;
//			printf("fof_list has proper type\n");
                        if(isEqual($<unode>1->type , $<unode>3->type)){
                                $<unode>$->type=$<unode>1->type;
                        }
                        else{
                                $<unode>$->type = ErrorType;
                                printf("Error: in line %d : incompatible types\n", lineNo);
                        }
                }
                else if(isEqual($<unode>1->type,ErrorType)){
                        $<unode>$->type = ErrorType;
                }
		else{
		//	$<unode>$->type = $<unode>1->type;
//			printf("*******Check this out*******\n");
			$<unode>$ = $<unode>1;
		}
		}
                else {
		//	$<unode>$->type = $<unode>1->type;
			$<unode>$=$<unode>1;
		}
		tempcount++;
		$<unode>$->tempid=tempcount;
		
		if($<unode>1->tempid>=0 && $<unode>3->tempid>=0){
			fprintf(intercode, "%d : t%d:=t%d %s t%d\n",lineNo,tempcount,$<unode>1->tempid, $<str>2, $<unode>3->tempid);
		}
		else if($<unode>1->tempid<0 && $<unode>3->tempid>=0){
			
			fprintf(intercode, "%d : t%d:=%s %s t%d\n",lineNo,tempcount,$<unode>1->ste->lexeme, $<str>2, $<unode>3->tempid);
		}
		else if($<unode>1->tempid>=0 && $<unode>3->tempid<0){
			fprintf(intercode, "%d : t%d:=t%d %s %s\n",lineNo,tempcount,$<unode>1->tempid, $<str>2, $<unode>3->ste->lexeme);
		}
		else{
			fprintf(intercode, "%d : t%d:=%s %s %s\n",lineNo,tempcount,$<unode>1->ste->lexeme, $<str>2, $<unode>3->ste->lexeme);
		}
		Quad* newquad=(Quad*)malloc(sizeof(Quad));
		newquad->type=0;	//Assignment icode type
		newquad->op=strdup($<str>2);
		newquad->restemp=tempcount;
		newquad->switch3=1;
		if($<unode>1->tempid>=0){
			newquad->switch1=1;
			newquad->arg1temp=$<unode>1->tempid;
		}
		else{
			newquad->switch1=0;
			newquad->arg1=$<unode>1->ste;
		}
		
		if($<unode>3->tempid>=0){
			newquad->switch2=1;
			newquad->arg2temp=$<unode>3->tempid;
		}
		else{
			newquad->switch2=0;
			newquad->arg2=$<unode>3->ste;
		}
		addicode(newquad);
		if($<unode>1->code==NULL){
//			printf("got null code in simple expression");
			if($<unode>3->code==NULL){
			Icode* newcode=(Icode*)malloc(sizeof(Icode));	
			newcode->next=NULL;
			newcode->code=newquad;
			$<unode>$->code=newcode;
			}
			else{
			$<unode>$->code=append_line_to_list($<unode>3->code, newquad);
			}
		}
		else{
			if($<unode>3->code!=NULL){
			$<unode>$->code=append_codelists($<unode>1->code, $<unode>3->code);
			$<unode>$->code=append_line_to_list($<unode>$->code, newquad);
			}
			else{
			$<unode>$->code=append_line_to_list($<unode>1->code, newquad);
			}
		}
		
	}
        ;
factor:
        '(' expression ')'	
	{
		//printf("bracketed expression\n");
		$<unode>$=$<unode>2;
	}
        |NOT factor
	{
		$<unode>$=$<unode>2;
		//put -val here
	}
        |variable_designator	
	{
		//printf("variable_designator\n");
		//need to send up only type here
		//make sure everything is declared
		$<unode>$=(Node*)malloc(sizeof(Node));
		if($<ste>1==NULL)printf("SERIOUS ERROR: null ste for var desig\n");
		$<unode>$->type=$<ste>1->type;
		if($<ste>1->isdecl==0){
		printf("Error: in line %d: \" %s \" is used but not declared\n",lineNo, $<ste>1->lexeme);
		}
		$<unode>$->isConst=0;//Change this later for CONST
		$<unode>$->ste=$<ste>1;
		$<unode>$->tempid=-1;
		$<unode>$->code=$<ste>1->code;
//		printf("var des\n");
	}
	|function_call	
	{
//		printf("function call\n");
		$<unode>$=$<unode>1;
		$<unode>$->isConst=0;
//		printf("\n\nin function_call\n\n\n");
//		dumpicode($<unode>$->code, stdout, stdout);
		//$<unode>$->code=NULL;
	}
        |constant_literal	
	{
		$<unode>$=$<unode>1;
		//printf("constant literal\n");
//		$<unode>$=(Node*)malloc(sizeof(Node));
//		$<unode>$->type=$<unode>1->type;
//		printf("Line %d: Passing on to factor Type %d\n",lineNo, $<unode>$->type->type);
	}
	|value_constructor	{
		//printf("value constructor\n");
		$<unode>$=$<unode>1;
		$<unode>$->isConst=0;
		$<unode>$->code=NULL;
	}
	;
value_constructor:
        set_constructor
        ;
set_constructor:
        type_identifier set_constructed_value ;

set_constructed_value:
        '{' '}'
        |'{' member_list '}'
        ;
member_list:
        member
        |member_list ',' member
        ;

member:
        interval
        |singleton ;
interval:
        ordinal_expression ELLIPSIS ordinal_expression;

singleton:
        ordinal_expression ;

field_identifier:
        qualified_identifier
	{
		$<ste>$=$<ste>1;
	}
        ;
function_call:
        variable_designator actual_parameters
	{
//		printf("FUNC call parsed\n");
		$<unode>$=(Node*)malloc(sizeof(Node));
//		printf("unode created\n");
//		if($<ste>1 == NULL)printf("BIG ERROR\n");
//		if($<ste>1->type==NULL)printf("ERROR\n");
		if($<ste>1->isdecl==0 || $<ste>1->type->type!=TYPE_PROCEDURE ){
			printf("Error: in line %d: procedure %s not defined\n", lineNo, $<ste>1->lexeme);
			$<unode>$->type=ErrorType;
		}
		else{
		//	printf("Valid procedure name\n");
		//traverse($<ste>1->type->args);
		if(isCompatible($<ste>1->type->args, $<unode>2)){
			$<unode>$->type=$<ste>1->type->descriptor;
		}
		else{
			$<unode>$->type=ErrorType;
			printf("Error: in line %d: Incompatible proc call\n", lineNo);
		}}
		Quad* newquad=(Quad*)malloc(sizeof(Quad));
		newquad->type=12;
		newquad->switch3=1;
//		printf("value of tempcount in function call %d\n", tempcount);
		//tempcount-=4;	//arbit
		newquad->restemp=++tempcount;
		$<unode>$->tempid=tempcount;
//		printf("tempcount is %d\n",tempcount);
		newquad->arg1=$<ste>1;
		newquad->arg1temp=$<unode>2->numparams;
		if($<unode>2->code!=NULL){
			$<unode>$->code=append_line_to_list($<unode>2->code, newquad);
		}
		else{
			Icode* list=(Icode*)malloc(sizeof(Icode));
			list->next=NULL;
			list->code=newquad;
			$<unode>$->code=list;
		}
	/* 	$<unode>$=(Node*)malloc(sizeof(Node));
		//check if $<ste>1 is of type procedure
		if(isCompatible($<ste>1->type->args, $<unode>2)){
			$<unode>$->type=$<ste>1->type->descriptor;
		}
		else{
			$<unode>$->type = ErrorType;
			printf("Error: in line %d: actual parameters not compatible with formal parameters of procedure %s\n", lineNo, $<ste>1->lexeme);
		}
	*/
	}
	;

qualified_identifier:
	IDENTIFIER
	{
		//printf("here");
		//printf("##############Lexeme: %s", $<str>1);
		SymbolTableEntry *iden_entry=lookup(scope_stack->top, $<str>1);
		if(iden_entry==NULL){
			//printf("Lexeme %s not found\n",$<str>1);
			iden_entry=(SymbolTableEntry*)malloc(sizeof(SymbolTableEntry));
			iden_entry->lexeme=$<str>1;
			//iden_entry->lexeme=(char*)malloc(100);
			//strcpy(iden_entry->lexeme,$<str>1);
			iden_entry->type=NULL;
			iden_entry->idclass=_UNKNOWN;
			iden_entry->next=NULL;
			iden_entry->isdecl=0;//FALSE
			append(scope_stack, iden_entry);
		}
		
		$<ste>$=iden_entry;
	/*	if($<ste>$->type==NULL)printf("Lexeme: %s Error3",$<ste>$->lexeme);
		else
			printf("Lexeme %s Type %d checked out from Symbol Table\n", $<ste>$->lexeme, $<ste>$->type->type);
*/	}
	;
constant_literal:
        INTEGER_LIT	
	{
		//printf("Integer constant parsed\n");
		$<unode>$=(Node*)malloc(sizeof(Node));
		$<unode>$->type=ZType;
		$<unode>$->valint=atoi($<str>1);
		$<unode>$->isConst=1;
		tempcount++;
//		printf("%d : t%d:=%s\n",lineNo,tempcount, $<str>1);
		$<unode>$->tempid=tempcount;
		

		Quad* newquad=(Quad*)malloc(sizeof(Quad));
		newquad->type=2;	//Copy constant
		newquad->switch3=1;
		newquad->restemp=tempcount;
		newquad->typeofconst=TYPE_INT;
		newquad->str=$<str>1;
		addicode(newquad);
		Icode* newcode=(Icode*)malloc(sizeof(Icode));
		newcode->next=NULL;
		newcode->code=newquad;
		$<unode>$->code=newcode;
		
	}
	|REAL_LIT
	{
		//printf("Real constant parsed\n");
		$<unode>$=(Node*)malloc(sizeof(Node));
		$<unode>$->type=RealType;
		tempcount++;
		//fprintf(intercode, "%d : t%d:=%s\n",lineNo,tempcount, $<str>1);
//		printf("%d : t%d:=%s\n",lineNo,tempcount, $<str>1);
		$<unode>$->tempid=tempcount;
		Quad* newquad=(Quad*)malloc(sizeof(Quad));
		newquad->type=2;	//Copy constant
		newquad->switch3=1;
		newquad->restemp=tempcount;
		newquad->typeofconst=TYPE_REAL;
		newquad->str=$<str>1;
		addicode(newquad);
		Icode* newcode=(Icode*)malloc(sizeof(Icode));
		newcode->next=NULL;
		newcode->code=newquad;
		$<unode>$->code=newcode;
	}
	
	|STRING_LIT
 	{
		//printf("String constant parsed\n");
		$<unode>$=(Node*)malloc(sizeof(Node));
		$<unode>$->type=CharType;
		//printf("String type %d\n",$<unode>$->type->type);
		$<unode>$->valchar=$<str>1[0];
		$<unode>$->isConst=1;
		tempcount++;
		fprintf(intercode, "%d : t%d:=%s\n",lineNo,tempcount, $<str>1);
		$<unode>$->tempid=tempcount;
		Quad* newquad=(Quad*)malloc(sizeof(Quad));
		newquad->type=2;	//Copy constant
		newquad->switch3=1;
		newquad->restemp=tempcount;
		newquad->typeofconst=TYPE_STRING;
		newquad->str=$<str>1;
		addicode(newquad);
		Icode* newcode=(Icode*)malloc(sizeof(Icode));
		newcode->next=NULL;
		newcode->code=newquad;
		$<unode>$->code=newcode;
	}
	
	;
term_operator:
	'+'
	{
		$<str>$=(char*)malloc(sizeof(char)*2);
		strcpy($<str>$,"+");
	}
	|'-'
	{
		$<str>$=(char*)malloc(sizeof(char)*2);
		strcpy($<str>$,"-");
	}
	|OR
	{
		$<str>$=(char*)malloc(sizeof(char)*3);
		strcpy($<str>$,"OR");
	}
	;
factor_operator :
        '*'
	{
		$<str>$=(char*)malloc(sizeof(char)*2);
		strcpy($<str>$,"*");
	}
	|'/'
	{
		$<str>$=(char*)malloc(sizeof(char)*2);
		strcpy($<str>$,"/");
	}
	|MOD
	{
		$<str>$=(char*)malloc(sizeof(char)*4);
		strcpy($<str>$,"MOD");
	}
	|DIV
	{
		$<str>$=(char*)malloc(sizeof(char)*4);
		strcpy($<str>$,"DIV");
	}
	|AND
	{
		$<str>$=(char*)malloc(sizeof(char)*4);
		strcpy($<str>$,"AND");
	}
	;
relational_operator:
        '='
	{
		$<str>$=(char*)malloc(sizeof(char)*2);
		strcpy($<str>$,"=");
	}
        |NEQ
	{
		$<str>$=(char*)malloc(sizeof(char)*4);
		strcpy($<str>$,"NEQ");
	}
        |'<'
	{
		$<str>$=(char*)malloc(sizeof(char)*2);
		strcpy($<str>$,"<");
	}
        |'>'
	{
		$<str>$=(char*)malloc(sizeof(char)*2);
		strcpy($<str>$,">");
	}
        |LEQ
	{
		$<str>$=(char*)malloc(sizeof(char)*4);
		strcpy($<str>$,"LEQ");
	}
        |GEQ
	{
		$<str>$=(char*)malloc(sizeof(char)*4);
		strcpy($<str>$,"GEQ");
	}
        |'#'
	{
		$<str>$=(char*)malloc(sizeof(char)*2);
		strcpy($<str>$,"#");
	}
	;

module_body:
        initialization_body
	{
//		printf("module_body parsed\n");
		$<unode>$=$<unode>1;
	}
        |initialization_body finalization_body 
	{
//		printf("module_body and finally parsed\n");
		$<unode>$=$<unode>1;
                if(isEqual($<unode>2->type, ErrorType)){
                        $<unode>$=$<unode>2;
                }
	}

        ;
initialization_body:
        BEG block_body
	{
		$<unode>$=$<unode>2;
	}
        ;

finalization_body:
        FINALLY block_body
	{
		$<unode>$=$<unode>2;
	}
        ;
block_body:
        normal_part
	{
		//printf("block body parsed\n");
		$<unode>$=$<unode>1;
		//printf("normal part\n");
		//dumpicode($<unode>$->code, stdout, stdout);
		//printf("end\n");
//		printf("end of normal part%d\n",tempcount);
	}
        |normal_part EXCEPT exceptional_part
	{
		$<unode>$=$<unode>1;
		if(isEqual($<unode>3->type, ErrorType)){
			$<unode>$=$<unode>3;
			$<unode>$->code=NULL;
		}
		
	}
        ;
normal_part:
        statement_sequence
	{
		//printf("Normal part parsed\n");
		$<unode>$=$<unode>1;
//		printf("st seq %d\n",tempcount);
	}
        ;
exceptional_part:
        statement_sequence
	{
		$<unode>$=$<unode>1;
	}
        ;
statement_sequence:
        statement
	{
//		printf("statement parsed\n");
//		printf("st %d\n",tempcount);
		$<unode>$=$<unode>1;
//		if($<unode>$->code==NULL)printf("statement got no code");
//		else{
//			printf("code type %d id %d\n",$<unode>$->code->code->type, $<unode>$->code->code->arg1temp);
//		 dumpicode($<unode>$->code, stdout, stdout);
//		}
	}
        |statement_sequence ';' statement	
	{
		//printf("statement sequence parsed\n");
	/*	if($<unode>3->type==NULL)printf("yes");
		if(isEqual($<unode>3->type, ErrorType)){
			$<unode>$=$<unode>3;
		}*/
//		printf("st %d\n",tempcount);
//		if($<unode>1->code==NULL)printf("Recieved no code");
//		else{
//			
//			printf("got code: appending next statement");
//		}
		if($<unode>3->code==NULL){
			$<unode>$->code=$<unode>1->code;
		}
		else{
			$<unode>$->code=append_codelists($<unode>1->code, $<unode>3->code);
		}
//		if($<unode>$->code==NULL)printf("statement seq got no code");
//		else {
//			printf("appended successfully ");
//			printf("dumping code in statement_seq\n");
//			dumpicode($<unode>$->code, stdout, stdout);
//			printf("code ends\n");
			
//		}
	}

        ;
statement:
	{
		$<unode>$=(Node*)malloc(sizeof(Node));
		$<unode>$->code=NULL;
	}
	|PRINT
	{
		Quad* newquad=(Quad*)malloc(sizeof(Quad));
		newquad->type=13;
		newquad->op=(char*)malloc(50*sizeof(char));
		strcpy(newquad->op,"\tli $v0, 1\n\tlw $a0, 0($sp)\n\tsyscall\n");
		Icode* list=(Icode*)malloc(sizeof(Icode));
		list->next=NULL;
		list->code=newquad;
		$<unode>$->code=list;
		$<unode>$->type=VoidType;
		//return
	}
	
        |assignment_statement	
	{
		//printf("Line %d:assignemnt statement parsed\n", lineNo);
		$<unode>$=$<unode>1;
//		if($<unode>$->code==NULL)printf("assignment got no code");
//		else {
//			printf("got code: ");
			//dumpicode($<unode>$->code, stdout);
//		}
		$<unode>$->type=VoidType;
	/*
		if(isEqual($<unode>$->type, ErrorType))
			printf("Error in assignment statement\n");
		else
			printf("Assignment statement parsed\n");
	*/	
	}
	|procedure_call		
	{
		//printf("proc call");
		$<unode>$=$<unode>1;
		//printf(" in proc call\n");
		//dumpicode($<unode>$->code, stdout, stdout);
		//printf("end\n");
		//$<unode>$->code=NULL;
	/*	if(isEqual($<unode>$->type, ErrorType)){
			printf("Error in procedure call\n");
		}
		else printf("Procedure call valid\n");
	*/
	}
        |return_statement
	{
		//printf("return statement parsed\n");
		
	}
        |retry_statement
	{
		//printf("retry statement parsed\n");
	}
        |with_statement
	{
		//printf("with statement\n");
	}
	|if_statement
	{
//		printf("if statement parsed\n");
//		printf("Dumping code\n");
		//dumpicode($<unode>1->code, stdout);
//		printf("Code dumped\n");
	}
        |case_statement
	{
		//printf("case statemtn parsed\n");
	}
        |while_statement
	{	
		//printf("while statement parsed\n");
	}
        |repeat_statement
	{
		//printf("repeat statement parsed\n");
	}
        |loop_statement
	{
		//printf("loop statement parsed\n");
	}
        |exit_statement
	{
		//printf("exit statement parsed\n");
	}
        |for_statement
	{
		//printf("for statement parsed\n");
		$<unode>$=(Node*)malloc(sizeof(Node));
		$<unode>$->type=VoidType;
		$<unode>$->code=$<unode>1->code;
	}
        ;
with_statement:
        WITH record_designator DO statement_sequence END
        {
               is_in_with=0;
//               printf("\nis in with = %d done\n\n",is_in_with);
         }
	;
record_designator:
        variable_designator
	{
		$<ste>$=$<ste>1;
		is_in_with=1;
                //printf("\n\n\nrecord designator parsing start \n\n\n");
                lexeme_with=$<ste>1->lexeme;
                $<ste>$=$<ste>1;
                printf("\nrecord designator parsed\n");
                //check if idclass is record

                //check if idclass is record
	}
	; 
assignment_statement:
	variable_designator ASS_OP expression
        {
		//printf("dumping expression\n");
		//dumpicode($<unode>3->code, stdout, stdout);
	//	printf("end\n");
		$<unode>$=(Node*)malloc(sizeof(Node));
//		printf("assignment statement parsed\n");
		//printf("ere");
		//type check : type of $<ste>1 should be same as $<unode>3
		//$<unode>$=(Node*)malloc(sizeof(Node));
//		if($<ste>1->type!=NULL){
//			printf("Type of lhs: %d Width %d Offset %d",$<ste>1->type->type, $<ste>1->width, $<ste>1->offset);
//		}
//		else{
//			printf("Type of lhs : NULL"); 
//		}
//		printf("\t Type of rhs: %d\n",$<unode>3->type->type);
		//printf("here");
		if($<ste>1->isdecl==0){
			printf("Error: in line %d: variable \" %s \" is used but not declared\n", lineNo, $<ste>1->lexeme);
			$<unode>$->type=ErrorType;
		}
		else{
			if(isEqual($<unode>3->type,ErrorType)){
				$<unode>$->type = ErrorType;
			}
			else if (isEqual($<ste>1->type, $<unode>3->type )){
				$<unode>$->type = VoidType;			
			}
			else{
				$<unode>$->type = ErrorType;
				printf("Error: in line %d: expression of type %d cannot be assigned to variable of type %d\n",lineNo, $<unode>3->type->type, $<ste>1->type->type);
			}
			$<unode>$->type=VoidType;
		}
	
		if($<unode>3->tempid>=0){
		fprintf(intercode, "%d : %s:=t%d\n",lineNo,$<ste>1->lexeme, $<unode>3->tempid);
		}
		else{
		fprintf(intercode,"%d: %s:=%s\n",lineNo,$<ste>1->lexeme,$<unode>3->ste->lexeme);
		}
		
		Quad* newquad=(Quad*)malloc(sizeof(Quad));
		newquad->type=1;	//Single Assignment icode type
		newquad->res=$<ste>1;
		//printf("newquad->res->offset = %d\n",newquad->res->offset);
		newquad->switch3=0;
//		printf("Offset here:%d\n",$<ste>1->offset);		
		if($<unode>3->tempid>=0){
			newquad->switch1=1;
			newquad->arg1temp=$<unode>3->tempid;
		}
		else{
			newquad->switch1=0;
			newquad->arg1=$<unode>3->ste;
		}
		addicode(newquad);
//		if($<unode>3->code==NULL)printf("ass st did not get code");
//		else {
//			printf("before adding:\n");
			//dumpicode($<unode>3->code, stdout);
//		}
		if($<ste>1->code!=NULL){
//			printf("came here offset %d\n", $<ste>1->code->offset);
			
			$<unode>3->code=append_codelists($<unode>3->code,$<ste>1->code);
			//$<ste>1=NULL;
			newquad->offset=$<ste>1->code->offset;
			//dumpicode($<unode>3->code, stdout);
//			printf("going out");
		}
//		else{
//			printf("clean variable\n");
//		}
		$<unode>$->code=append_line_to_list($<unode>3->code, newquad);
		
//		printf("after appending:\n");
		//dumpicode($<unode>$->code, stdout);
//		printf("dumped\n");



	}
       ;
procedure_call:
        procedure_designator
	{
		//printf("proc call parsed\n");
		$<unode>$=(Node*)malloc(sizeof(Node));
		//printf("unode created\n");
		//if($<ste>1 == NULL)printf("BIG ERROR\n");
		//if($<ste>1->type==NULL)printf("ERROR\n");
                if($<ste>1->isdecl==0||$<ste>1->type->type!=TYPE_PROCEDURE){
                        printf("Error: in line %d: procedure %s not defined\n", lineNo, $<ste>1->lexeme);
                        $<unode>$->type=ErrorType;
			$<unode>$->code=NULL;
                }
                else{
                //      printf("Valid procedure name\n");
                	if($<ste>1->type->args==NULL){
                        	$<unode>$->type=VoidType;
         			Quad* newquad=(Quad*)malloc(sizeof(Quad));
				newquad->type=10;
				newquad->arg1=$<ste>1;
				newquad->arg1temp=0;
				Icode* list=(Icode*)malloc(sizeof(Icode));
				list->next=NULL;
				list->code=newquad;
				$<unode>$->code=list;
		       	}
                	else{
                        	$<unode>$->type=ErrorType;
                        	printf("Error: in line %d: Incompatible proc call\n", lineNo);
                	}

		}
	}
        |procedure_designator actual_parameters
	{
		$<unode>$=(Node*)malloc(sizeof(Node));
		if($<ste>1->isdecl==0 || $<ste>1->type->type!=TYPE_PROCEDURE ){
			printf("Error: in line %d: procedure %s not defined\n", lineNo, $<ste>1->lexeme);
			$<unode>$->type=ErrorType;
		}
		else{
			if(isCompatible($<ste>1->type->args, $<unode>2)){
				$<unode>$->type=VoidType;
				Quad* newquad=(Quad*)malloc(sizeof(Quad));
				newquad->type=10;
				newquad->arg1=$<ste>1;
				newquad->arg1temp=$<unode>2->numparams;
				if($<unode>2->code!=NULL){
					$<unode>$->code=append_line_to_list($<unode>2->code, newquad);
				}
				else{
					Icode* list=(Icode*)malloc(sizeof(Icode));
					list->next=NULL;
					list->code=newquad;
					$<unode>$->code=list;
				}
			}
			else{
				$<unode>$->type=ErrorType;
				printf("Error: in line %d: Incompatible proc call\n", lineNo);
			}
		}
	}
        ;
procedure_designator:
        variable_designator
	{
		$<ste>$=$<ste>1;
//		printf("isdecl in proc_des %d",$<ste>$->isdecl);
	/*	if($<ste>$->type==NULL)printf("Error1\n");
		else{
			printf("ste type %d", $<ste>$->type->type);
		}
          */      //check if idclass is procedure
	}
	;

actual_parameters:
        '(' ')'
	{
		$<unode>$=(Node*)malloc(sizeof(Node));
		$<unode>$->type=VoidType;
		$<unode>$->numparams=0;
		$<unode>$->code=NULL;
	}
        |'(' actual_parameter_list ')'
	{
//		printf("Actual param list parsed\n");
		$<unode>$=$<unode>2;
	}
        ;
actual_parameter_list:
        actual_parameter
	{
                //printf("First param  ");
                $<unode>$=$<unode>1;
                $<unode>$->next=NULL;
		$<unode>$->numparams=1;
		//printf(" in actaul param tempcount %d\n", tempcount);
		//if($<unode>$->code!=NULL)dumpicode($<unode>$->code, stdout, stdout);
		//printf("end of code\n");
//              printf("Type:%d\n", $<unode>$->type->type);

	}
	|actual_parameter_list ',' actual_parameter
	{
//		printf("Param added  ");
		$<unode>$=append_at_end($<unode>1,$<unode>3);
		$<unode>$->code=append_codelists($<unode>1->code, $<unode>3->code);
		$<unode>$->numparams=$<unode>1->numparams+1;
////		printf(" in actaul param\n");
//		if($<unode>$->code!=NULL)dumpicode($<unode>$->code, stdout, stdout);
//		printf("end of code\n");
//		//$<unode>3->next = $<unode>1;
		//$<unode>$=$<unode>3;
//		printf("Type:%d\n", $<unode>$->type->type);
	}
        ;
actual_parameter:
        expression
	{
		$<unode>$=(Node*)malloc(sizeof(Node));
		$<unode>$->type=$<unode>1->type;
		$<unode>$->valint=$<unode>1->valint;
		$<unode>$->valchar=$<unode>1->valchar;
		$<unode>$->isConst=$<unode>1->isConst;
		$<unode>$->tempid=$<unode>1->tempid;
		$<unode>$->ste=$<unode>1->ste;
		$<unode>$->offset=$<unode>1->offset;
		$<unode>$->width=$<unode>1->width;
//		printf("tempcount in expression %d\n", tempcount);
		
		
		
//		printf("First param  ");
		$<unode>$->next=NULL;
//		printf("Type:%d\n", $<unode>$->type->type);
		//$<unode>$->numparams=1;
		Quad* newquad=(Quad*)malloc(sizeof(Quad));
		newquad->type=9;
		if($<unode>1->code!=NULL){
			newquad->arg1temp=$<unode>1->code->code->restemp;
			//printf("Actual param Temporary numbner %d\n",newquad->arg1temp);
			if($<unode>1->ste==NULL){
				//printf("ste null#####################\n");
				newquad->switch1=1;
				$<unode>$->code=append_line_to_list($<unode>1->code, newquad);
			}
			else {
				//printf("ste NOT null#####################\n");
				newquad->switch1=0;
				newquad->arg1=$<unode>1->ste;
				newquad->offset=$<unode>1->ste->code->offset;
				$<unode>$->code=append_line_to_list($<unode>1->ste->code, newquad);
			}
//			printf("\n\n\ncame here\n\n\n\n\n");
		}
		else{
			newquad->switch1=0;
			newquad->arg1=$<unode>1->ste;
			Icode* list=(Icode*)malloc(sizeof(Icode));
			list->next=NULL;
			list->code=newquad;
			$<unode>$->code=list;
		}
		//dumpicode($<unode>$->code,stdout,stdout);
		//printf("parse ends\n");

	}
	|basic_type
	;
variable_designator:
        entire_designator
	{
		if(is_in_with==1)
                {
  //                      printf("In with statement with lexeme of record  : %s \n",lexeme_with);
                        SymbolTableEntry* newsymbol=(SymbolTableEntry*)malloc(sizeof(SymbolTableEntry));
                        SymbolTableEntry* typesymbol=lookup(scope_stack->top,lexeme_with);

                        //printf("jfvhdjvbfcjxvcjv %s ",typesymbol->type->descriptor->next->name);

                        TypeCons* temp=typesymbol->type->descriptor->descriptor;

                        while(temp!=NULL)
                        {

//                                printf("Matching %s %s %d\n", temp->name, $<ste>1->lexeme, temp->type);

                                if (strcmp(temp->name, $<ste>1->lexeme)==0)
                                {
  //                                      printf("Printing lexeme of temp variable\n");
                                        newsymbol->type=temp;
                                        break;
                                }
                                //printf("temp.next is done \n");
                                temp=temp->next;//printf("no segmentation fault in tem.next \n");
                        }
                        if(temp==NULL)
                        {
                                printf("Error: in line %d: field \" %s \" not found in record \" %s \"\n",lineNo, $<ste>1->lexeme,lexeme_with);
                                newsymbol->isdecl=0;
                        }
                        else
                        {
                                newsymbol->isdecl=1;
                        }
                        newsymbol->lexeme=lexeme_with;
                        //newsymbol->type= ;///
                        $<ste>$=newsymbol;

                }
		else{
//		printf("Passing entire_desig to variable desig\n");
		$<ste>$=$<ste>1;
//		printf("value of tempcount %d in variable desig \n",tempcount);
		}
		//$<ste>$->offset=0;
//		$<ste>$=(SymbolTableEntry*)malloc(sizeof(SymbolTableEntry));
//		ste_copy($<ste>$,$<ste>1);
//		if($<ste>1->type==NULL)printf("Lexeme %s Error2", $<ste>$->lexeme);
//		else printf("Lexeme %s ent: %d", $<ste>$->lexeme, $<ste>$->type->type);
		//$<ste>$=$<ste>1;
		
	}
	|indexed_designator
	{
/*		printf("parsed indexd_designator\n");
		$<ste>$=(SymbolTableEntry*)malloc(sizeof(SymbolTableEntry));
		$<ste>$->type=$<ste>1->type->descriptor;
		printf("Array indexed variable type %d\n",$<ste>$->type->type);
		$<ste>$->isdecl=$<ste>1->isdecl;
		$<ste>$->lexeme=$<ste>1->lexeme;
*/
//		$<ste>$=$<ste>1;
	}
        |selected_designator
        |dereferenced_designator
	;
dereferenced_designator:
        pointer_variable_designator '^'
        ;
pointer_variable_designator:
        variable_designator
	{
		$<ste>$=$<ste>1;
                $<ste>$->idclass=_POINTER;
	}
        ;

selected_designator:
        record_variable_designator '.' field_identifier
{
                SymbolTableEntry* newsymbol=(SymbolTableEntry*)malloc(sizeof(SymbolTableEntry));
//                printf("Selected designator : %s %s\n",$<ste>1->lexeme,$<ste>1->type->name);
                //lookup ste type name in symbol table
//              SymbolTableEntry* typesymbol=lookup(scope_stack->top, $<ste>1->type->name);
                //check if field $<ste>3->lexeme is present in $<ste>1->type
                TypeCons* temp=$<ste>1->type->descriptor;
                while(temp!=NULL)
                {
  //                      printf("Matching %s %s %d\n", temp->name, $<ste>3->lexeme, temp->type);

                        if (strcmp(temp->name, $<ste>3->lexeme)==0)
                        {
    //                            printf("Printing lexeme of temp\n");
                                newsymbol->type=temp;
                                break;
                        }
                        temp=temp->next;
                }
                if(temp==NULL){
                        printf("Error: in line %d: field \" %s \" not found in record \" %s \"\n",lineNo, $<ste>3->lexeme, $<ste>1->lexeme);
                        newsymbol->isdecl=0;
                }
                else{
                        newsymbol->isdecl=1;
			//newsymbol->
			newsymbol->type=temp;
			newsymbol->code=NULL;
			newsymbol->lexeme=$<ste>1->lexeme;
			newsymbol->offset=$<ste>1->offset+temp->offset_in_record;
			newsymbol->code=NULL;
			//printf("Sending offset %d\n",newsymbol->offset);

                }
                newsymbol->lexeme=$<ste>1->lexeme;
                //newsymbol->type= ;///
                $<ste>$=newsymbol;



                }
        ;
record_variable_designator:
        variable_designator
	{
		$<ste>$=$<ste>1;
                //check idclass
	}
        ;

indexed_designator:
        array_variable_designator '[' ie_list ']'
	{
		
		$<ste>$=(SymbolTableEntry*)malloc(sizeof(SymbolTableEntry));
		$<ste>$->type=$<ste>1->type->descriptor;
//		printf("Array indexed variable type %d\n",$<ste>$->type->type);
//		printf("Array indexed variable type %d\n",$<ste>$->type->type);
		$<ste>$->isdecl=1;
//		printf("everything fine till here");	
		
//		printf("everything fine till here");	
		$<ste>$->lexeme=$<ste>1->lexeme;
//		printf("everything fine till here");	
		$<ste>$->next=NULL;
		$<ste>$->offset=$<ste>1->offset;
//		printf("everything fine till here");	
		if (argcount != $<ste>1->type->dims)
		    printf("ERROR: In line %d: Number of dimension does not match\n",lineNo);
                argcount=0;
//		printf("check0");
		//if($<ste>$->lexeme!=NULL)printf("In indexed designator Lexeme %s\n",$<ste>1->lexeme);
//		printf("check 1 ");
		
		//Need to generate code for convertingt the ie_list into an offset
		int i=0;
		int tempid=++tempcount;
		Quad* newquad;
//		printf("check 0 ");
		if($<unode>3->tempid>=0){
			tempid--;
			tempcount--;
			$<ste>$->code=$<unode>3->code;
		}
		else{
			newquad=(Quad*)malloc(sizeof(Quad));
			newquad->type=1;//Single Copy assignment
			newquad->restemp=tempid;
			newquad->switch3=1;
			newquad->switch1=0;
			newquad->arg1=$<unode>3->ste;
			$<ste>$->code=append_line_to_list($<unode>3->code, newquad);
		}
		//put in list
//		printf("check 1 dims: %d", $<ste>1->type->dims);

		Node* temp=$<unode>3;
		for(i=1;i< $<ste>1->type->dims;i++){
//			printf("came inside loop");
			if(temp==NULL){
				printf("Error: in line %d: dimension mismatch\n",lineNo);
				break;
			}
			temp=temp->next;
			//t=t*size
			newquad=(Quad*)malloc(sizeof(Quad));
			newquad->type=11;//Constant op
			newquad->restemp=tempid;
			newquad->switch3=1;
			newquad->switch1=1;
			newquad->arg1temp=tempid;
			newquad->switch2=1;
//			if($<ste>1==NULL)printf("NULL1\n");
//			if($<ste>1->type==NULL)printf("NULL2\n");
//			if($<ste>1->type->index==NULL)printf("NULL2\n");
//			if($<ste>1->type->index[i]==NULL)printf("NULL3\n");
			
	
			newquad->arg2temp=$<ste>1->type->index[i]->size;
			newquad->op=(char*)malloc(sizeof(char)*2);
			strcpy(newquad->op,"*");
			$<ste>$->code=append_line_to_list($<ste>$->code, newquad);
			//t=t+index
			newquad=(Quad*)malloc(sizeof(Quad));
			newquad->type=0;//Assignment
			newquad->op=(char*)malloc(sizeof(char)*2);
			strcpy(newquad->op,"+");
			newquad->restemp=tempid;
			newquad->switch3=1;
			newquad->switch1=1;
			newquad->arg1temp=tempid;
			
			if(temp->tempid>=0){
				newquad->switch2=1;
				newquad->arg2temp=temp->tempid;
			}
			else{
				newquad->switch2=0;
				newquad->arg2=temp->ste;
			}
			$<ste>$->code=append_line_to_list($<ste>$->code, newquad);
		}
		//Multiply by size of arraytype
//		printf("check 2 ");
		newquad=(Quad*)malloc(sizeof(Quad));
		newquad->type=11;//Const op
		newquad->restemp=tempid;
		newquad->switch3=1;
		newquad->switch1=1;
		newquad->arg1temp=tempid;
		newquad->switch2=1;
		newquad->arg2temp=$<ste>1->type->descriptor->size;
		newquad->op=(char*)malloc(sizeof(char)*2);
		strcpy(newquad->op,"*");
		$<ste>$->code=append_line_to_list($<ste>$->code, newquad);
		$<ste>$->code->offset=tempid;
//		printf("sent offset :%d\n",tempid);
		//dumpicode($<ste>$->code, stdout);
	}
        ;
ie_list:
        index_expression
	{
//		printf("first");
                argcount++;
        }
        |ie_list ',' index_expression
	{
		argcount++;
//		printf("more start");
		//$<unode>$=(Node*)malloc(sizeof(Node));
		Quad* newquad=(Quad*)malloc(sizeof(Quad));
		
		$<unode>$=append_at_end($<unode>1, $<unode>3);
		if($<unode>1->tempid>=0 && $<unode>3->tempid>=0){
			//append codes
			$<unode>$->code=append_codelists($<unode>1->code,$<unode>3->code);
		}
		else if($<unode>1->tempid>=0 && $<unode>3->tempid<0){
			//code for 1
			$<unode>$->code=$<unode>1->code;
		}
		else if($<unode>1->tempid<0 && $<unode>3->tempid>=0){
			//code for 2
			$<unode>$->code=$<unode>3->code;
		}
		else {
			$<unode>$->code=NULL;
		}
//		printf("more end");
		
	}
        ;
index_expression:
        ordinal_expression
        {

                if (!isEqual($<unode>1->type,ZType))
  //                      printf("Parsed int type");

                
                        printf("ERROR: In line %d : The type of array does not match\n",lineNo);

        }
	;
array_variable_designator:
        variable_designator
	{
		$<ste>$=$<ste>1;
                //type check
	}
        ;

entire_designator:
        qualified_identifier
	{
		$<ste>$=$<ste>1;
		//printf("Lexeme: %s, offset: %d, width %d\n",$<ste>1->lexeme, $<ste>1->offset, $<ste>1->width);
		$<ste>$->code=NULL;
//		printf("Intercepting at entire_designator: Lexeme :%s ", $<ste>$->lexeme);
//		printf("isdecl:%d",$<ste>$->isdecl);
//		if($<ste>$->type!=NULL)printf("Type %d\n",$<ste>$->type->type);
//		else printf("Type NULL\n");
	}
        ;
return_statement:
        simple_return_statement
        |function_return_statement ;

simple_return_statement:
        RETURN
	{
		$<unode>$=NULL;
		returntype=NULL;
	}
	;

function_return_statement:
        RETURN expression
	{
		//printf("parsing return statemnt\n");
		$<unode>$=$<unode>2;
		if(returntype==NULL){
			returntype=$<unode>2->type;
		//	printf("return type of return st : %d\n",$<unode>2->type->type);
		}
		else{
			if(!isEqual(returntype, $<unode>2->type)){
				printf("Error: in line %d: Different return types do not match\n",lineNo);
			}
		}
		Quad* newquad=(Quad*)malloc(sizeof(Quad));
		newquad->type=7;
		newquad->width=0;
		//$<unode>2->code->width=0;
		//printf("return statement parsed num temp in return exp %d\n", $<unode>2->tempid);
		if($<unode>2->tempid>=0){
		//	printf("got expression\n");
			newquad->switch1=1;
			newquad->arg1temp=$<unode>2->tempid;
//			printf("tempid:%d\n",$<unode>2->tempid);
		}
		else{
			newquad->switch1=0;
			newquad->arg1=$<unode>2->ste;
			if($<unode>2!=NULL && $<unode>2->ste !=NULL && $<unode>2->ste->code!=NULL)newquad->offset=$<unode>2->ste->code->offset;
			else newquad->offset=0;
		}
		//printf("appending\n");
		//if($<unode>2->code==NULL) printf("exprsson code null\n");
		$<unode>$->code=append_line_to_list($<unode>2->code,newquad);
		//printf("parsed\n");	
	}
        ;

retry_statement:
        RETRY ;
if_statement:
        guarded_statements END
	{
                /*$<unode$=InitNode("if statement");
                if($<unode>1->type==Void){
                        $<unode>$->type=Void;
                }
                else{
                        $<unode>$->type = ErrorType;
                        f//printf(stderr,"Type error detected in line %d\n",lineNo);
                }*/
		Quad* newquad=(Quad*)malloc(sizeof(Quad));
		newquad->type=4;	//put label
		newquad->label=$<unode>$->tempid;
		$<unode>$=$<unode>1;
		$<unode>$->code=append_line_to_list($<unode>1->code, newquad);
	}
        |guarded_statements if_else_part END
	{
                /*$<unode$=InitNode("if statement");
                if($<unode>1->type==Void && $<unode>2->type==Void){
                        $<unode>$->type=Void;
                }
                else{
                        $<unode>$->type = ErrorType;
                        f//printf(stderr,"Type error detected in line %d\n",lineNo);
                }*/
//		printf("guarded if \n");
		$<unode>$=(Node*)malloc(sizeof(Node));	
		Quad* newquad=(Quad*)malloc(sizeof(Quad));
		labelcount++;
		newquad->type=5;	//unconditional jump
		newquad->label=labelcount;
		$<unode>$->code=append_line_to_list($<unode>1->code, newquad);
		


		newquad=(Quad*)malloc(sizeof(Quad));
		newquad->type=4;	//put label
		newquad->label=$<unode>1->tempid;
//		printf("\n\nGOT LABEL################%d\n\n",newquad->label);
		$<unode>$->code=append_line_to_list($<unode>$->code, newquad);
	
		//put else code
		$<unode>$->code=append_codelists($<unode>$->code, $<unode>2->code);
		
		//put exit label
		newquad=(Quad*)malloc(sizeof(Quad));
		newquad->type=4;	//put label
		newquad->label=labelcount;
		$<unode>$->code=append_line_to_list($<unode>$->code, newquad);
		
        }

        ;

guarded_statements:
        IF boolean_expression THEN statement_sequence elseif_list
	{
                $<unode>$=(Node*)malloc(sizeof(Node));
		/*if($<unode>2->type==ErrorType){
                        f//printf(stderr,"Error: condition type is not boolean in line %d", lineNo);
                        $<unode$->type=ErrorType;
                }
                else if($<unode>4->type==ErrorType|| $<unode>5->type==ErrorType){
                        $<unode>$->type=ErrorType;
                }
                else{
                        $<unode>$-type=Void;
                }*/
		if(isEqual($<unode>2->type,BooleanType)){
			labelcount++;
			int elselabel=labelcount;
						
			//make code for if st
//			printf("IF-PART\n");	

			Quad* newquad=(Quad*)malloc(sizeof(Quad));
			newquad->type=3;	//conditional jump icode type
			newquad->restemp=$<unode>2->tempid;
			newquad->switch3=1;
			newquad->label=elselabel;
			
//			printf("Dumping bool exp :");
			//dumpicode($<unode>2->code, stdout);
			
//			printf("Dumping if -part of statement :");
			//dumpicode($<unode>4->code, stdout);
			$<unode>$->code=append_line_to_list($<unode>2->code, newquad);
//			printf("Check");
			//dumpicode($<unode>$->code, stdout);
//			printf("***********");	
			//add if part
			$<unode>$->code=append_codelists($<unode>$->code, $<unode>4->code);
		/*	Quad* newquad=(Quad*)malloc(sizeof(Quad));
			newquad->type=4;	//unconditional jump icode type
			newquad->restemp=$<unode>2->tempid;
			newquad->switch3=1;
			newquad->label=elselabel;
		*/	
			$<unode>$->type=VoidType;
			$<unode>$->tempid=elselabel;	//Telling the parent where to put the else code. It is  NOT a tempid, just a placeholder in the node that was vacant
//			printf("at the end of guraded st\n");
			//dumpicode($<unode>$->code, stdout);
//			printf("end of code\n");
		}
		else{
			printf("Error: in line %d: condition not of type boolean\n", lineNo);
			$<unode>$->type=ErrorType;
			$<unode>$->code=NULL;
		}
		
        } 
       	;

elseif_list: /*eMpTy*/
	{
		$<unode>$=NULL;
	}
        |elseif_list ELSIF boolean_expression THEN statement_sequence
	{
//		printf("elseif not implemented\n");
		$<unode>$=NULL;
	}
        ;

if_else_part:
        ELSE statement_sequence	
	{
//		printf("else part parsed\n");
		$<unode>$=$<unode>2;
	}
	;
boolean_expression:
        expression
	{
//		printf("boolean expression parsed\n");
//		if($<unode>$->code!=NULL){
//			printf("dumping icode for bool exp");
			//dumpicode($<unode>$->code, stdout);
//		}
//		else{
//			printf("No code for u");
//		}
	}
	;
case_statement:
        CASE case_selector OF case_list END
        ;
case_selector:
        ordinal_expression
 	{
		//printf("case selector parsed\n");
	}
	;
case_list:
        case_alternative csca_list	
	{
		//printf("entire list parsed\n");
	}
        |case_alternative csca_list case_else_part	
	{
		//printf("entire list parsed\n");
	}
        ;
csca_list:/*eMpTy*/
        |csca_list '|' case_alternative
	{
		//printf("case added\n");
	}
        ;
case_else_part:
        ELSE statement_sequence ;

case_alternative:/*eMpTy*/
        |case_label_list ':' statement_sequence
	{
		//printf("case alternative parsed\n");
	}
        ;
case_label_list:
        case_label
	{
		//printf("case label list pasred\n");
	}
        |case_label_list ',' case_label
        ;
case_label:
        constant_expression
	{
		//printf("case label parsed\t");
	}
        |constant_expression ELLIPSIS constant_expression
        ;

while_statement:
        WHILE boolean_expression DO statement_sequence END
        ;
repeat_statement:
        REPEAT statement_sequence UNTIL boolean_expression;

loop_statement:
        LOOP statement_sequence END
        ;

exit_statement:
        EXIT;
for_statement:
        FOR control_variable_identifier ASS_OP initial_value TO final_value DO statement_sequence END
	{
		
		$<unode>$=(Node*)malloc(sizeof(Node));
//		printf("assignment statement parsed\n");
		//printf("ere");
		//type check : type of $<ste>1 should be same as $<unode>3
		//$<unode>$=(Node*)malloc(sizeof(Node));
//		if($<ste>2->type!=NULL){
//			printf("Type of lhs: %d",$<ste>2->type->type);
//		}
//		else{
//			printf("Type of lhs : NULL"); 
//		}
//		printf("\t Type of rhs: %d\n",$<unode>4->type->type);
		//printf("here");
		if($<ste>2->isdecl==0){
			printf("Error: in line %d: variable \" %s \" is used but not declared\n", lineNo, $<ste>2->lexeme);
			$<unode>$->type=ErrorType;
		}
		else{
			if(isEqual($<unode>4->type,ErrorType)){
				$<unode>$->type = ErrorType;
			}
			else if (isEqual($<unode>4->type , $<ste>2->type)){
				$<unode>$->type = VoidType;			
			}
			else{
				$<unode>$->type = ErrorType;
				printf("Error: in line %d: expression of type %d cannot be assigned to variable of type %d\n",lineNo, $<unode>4->type->type, $<ste>1->type->type);
			}
			$<unode>$->type=VoidType;
		}
	
		if($<unode>4->tempid>=0){
			fprintf(intercode, "%d : %s:=t%d\n",lineNo,$<ste>2->lexeme, $<unode>4->tempid);
		}
		else{
			fprintf(intercode, "%d : %s:=%s\n",lineNo,$<ste>2->lexeme, $<unode>4->ste->lexeme);
		}
		
		Quad* newquad=(Quad*)malloc(sizeof(Quad));
		newquad->type=1;	//Single Assignment icode type
		newquad->res=$<ste>2;
		newquad->switch3=0;
				
		if($<unode>4->tempid>=0){
		
			newquad->switch1=1;
			newquad->arg1temp=$<unode>4->tempid;
		}
		else{
			newquad->switch1=0;
			newquad->arg1=$<unode>4->ste;
		}
		addicode(newquad);
//		if($<unode>4->code==NULL)printf("ass st did not get code");
//		else {
//			printf("before adding:\n");
			//dumpicode($<unode>4->code, stdout);
//		}
		$<unode>$->code=append_line_to_list($<unode>4->code, newquad);
//		printf("after appending:\n");
		//dumpicode($<unode>$->code, stdout);


		//Put a Label LOOPSTART:
		
		newquad=(Quad*)malloc(sizeof(Quad));
		newquad->type=4;	//put label
		newquad->label=++labelcount;
		$<unode>$->code=append_line_to_list($<unode>$->code, newquad);
		
		//need to check if control variable is equal to final value
		//if it is GOTO LOOPEND
				
		newquad=(Quad*)malloc(sizeof(Quad));
		newquad->type=6;	//if x relop y
		newquad->op=(char*)malloc(sizeof(char)*3);
		strcpy(newquad->op, ">");
		labelcount++;
		newquad->label=labelcount;
		
		newquad->switch1=0;
		newquad->arg1=$<ste>2;
		
		
		if($<unode>6->tempid>=0){
		
			newquad->switch2=1;
			newquad->arg2temp=$<unode>6->tempid;
		}
		else{
			newquad->switch2=0;
			newquad->arg2=$<unode>6->ste;
		}
		
		if($<unode>6->code!=NULL){
			$<unode>$->code=append_codelists($<unode>$->code, $<unode>6->code);
		}
		$<unode>$->code=append_line_to_list($<unode>$->code, newquad);
	

		
	
		//<statements>
		
		$<unode>$->code=append_codelists($<unode>$->code, $<unode>8->code);
		


		//Increment control variable
				
		newquad=(Quad*)malloc(sizeof(Quad));
		newquad->type=2;	// x=1 copy constant
		newquad->switch3=1;
		newquad->restemp=++tempcount;
		newquad->typeofconst=TYPE_INT;
		newquad->str=(char*)malloc(sizeof(char)*2);
		strcpy(newquad->str,"1");
		$<unode>$->code=append_line_to_list($<unode>$->code, newquad);
		

		newquad=(Quad*)malloc(sizeof(Quad));
		newquad->type=0;	//Assignment icode type
		newquad->op=(char*)malloc(sizeof(char)*2);
		strcpy(newquad->op,"+");
		newquad->switch3=0;
		newquad->res=$<ste>2;
	
		newquad->switch1=0;
		newquad->arg1=$<ste>2;
		newquad->switch2=1;
		newquad->arg2temp=tempcount;
		
		$<unode>$->code=append_line_to_list($<unode>$->code, newquad);

		
		//GOTO HEAD
		
		
		newquad=(Quad*)malloc(sizeof(Quad));
		newquad->type=5;	//unconditional jump
		newquad->label=labelcount-1;
		$<unode>$->code=append_line_to_list($<unode>$->code, newquad);
		


		//Put LOOPEND:
		newquad=(Quad*)malloc(sizeof(Quad));
		newquad->type=4;	//put label
		newquad->label=labelcount;
		$<unode>$->code=append_line_to_list($<unode>$->code, newquad);


	

	}
        |FOR control_variable_identifier ASS_OP initial_value TO final_value BY step_size DO statement_sequence END
	{
//		printf("Step not implemented\n");
	}
        ;

control_variable_identifier:
        qualified_identifier
	{
		$<ste>$=$<ste>1;
		//check type
	}
        ;

initial_value:
        ordinal_expression
        ;

ordinal_expression:
        expression ;

final_value:
        ordinal_expression
        ;

step_size:
        constant_expression
        ;
%%
void yyerror(char *s) {
    fprintf(stderr, "%s\n", s);
}
int main() {
//	printf("1: ");
	init();
	intercode=fopen("intercode","w");
        yyparse();
	FILE* intercodefile=fopen("icode","w");
	//dumpicode(icodelist,intercodefile);
	close(intercodefile);
	close(intercode);
        printf("\n");
	return 0;
}

