enum IDEN_CLASS{
	_MODULE,
	_ARRAY,
	_PROCEDURE,
	_RECORD,
	_POINTER,
	_CONST,
	_VAR,
	_TYPENAME,
	_ERROR,
	_UNKNOWN,
	_TYPE
};
struct namelist{
	char* name;
	struct namelist* next;
};
typedef struct namelist NameList;
struct type_cons{
	int type;
	int d1;
	int d2;
	int dims;
	struct type_cons* descriptor;
	struct table_stack* args;
	struct type_cons** index;
	int size;
	char* name;
	struct type_cons* next;
	int offset_in_record;
};
typedef struct type_cons TypeCons;

struct symbol_table_entry{
	TypeCons* type;	
	enum IDEN_CLASS idclass;
	struct symbol_table_entry *next;
	int isdecl;
	char* lexeme;
	int label;
	int width;
	int offset;
	struct icode* code;
	struct table_stack* scope;
	int tempareasize;
	int localdatasize;
};
typedef struct symbol_table_entry SymbolTableEntry;

struct node{
	TypeCons* type;
	struct node* next;
	int valint;
	int valchar;//need ordinal type constants
	int isConst;
	int tempid;
	SymbolTableEntry* ste;
	struct icode* code;
	int offset;
	int width;
	int numparams;
	int size;
	TypeCons* returntype;
};
typedef struct node Node;

struct table_stack{
	SymbolTableEntry *top;
	int declhappening;
	struct table_stack *next;
	int fromCurrentScope;
	int offset;
	int width;
	int tempareasize;
};
typedef struct table_stack TableStack;
struct quad{
	int type;
	char* op;
	SymbolTableEntry* arg1;
	int arg1temp;
	int switch1;
	SymbolTableEntry* arg2;
	int arg2temp;
	int switch2;
	SymbolTableEntry* res;
	int restemp;
	int switch3;
	char* str;	//for constants
	int typeofconst;
	int label;
	int width,offset;
};
typedef struct quad Quad;
struct icode{
	Quad* code;
	int width, offset;
	struct icode* next;
};
typedef struct icode Icode;
